Scriptname _NBF_DetectNearbyEff extends Activemagiceffect

_NBF_MainScr Property NBFMainScr Auto
Actor Target

Event OnEffectStart(actor akTarget, actor akCaster)
	NBFMainScr.NBF_Log("[DetectNearbyEff] Adding Actor - " + akTarget.GetDisplayName() + " " + akTarget.GetDistance(Game.GetPlayer()))
	Target = akTarget
	if StorageUtil.FormListHas(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_SpawnedActorBaseList", Target.GetActorBase())
		Utility.wait(1.5)
		String TempNPCName = StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCNameByBaseID_" + Target.GetActorBase().GetFormID())
		if StorageUtil.GetFormValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) != Target
			NBFMainScr.NBF_Log("[DetectNearbyEff] - " + akTarget.GetDisplayName() + " Disabling default actor - " + TempNPCName)
			StorageUtil.SetFormValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_DisabledActorByName_" + TempNPCName, Target)
			Target.Disable()
			NBFMainScr.NBF_Log("[DetectNearbyEff] - " + akTarget.GetDisplayName() + " Disabling default actor")
			return
		endif
	endif
	Int ArrayLength = 7
	While ArrayLength > 0
		ArrayLength -= 1
		Faction TempFaction = NBFMainScr.FactionList[ArrayLength]
		if Target.IsInFaction(TempFaction) && Target.GetFactionRank(TempFaction) != 99 && Target.GetFactionRank(TempFaction) != -1
			StorageUtil.FormListAdd(NBFMainScr.NBFRegForm, "NBF_Actors_FactionIndex_" + ArrayLength, Target, False)
			StorageUtil.IntListAdd(NBFMainScr.NBFRegForm, "NBF_StoredActor_FactionIndex_" + Target, ArrayLength, false)
			StorageUtil.FormListAdd(NBFMainScr.NBFRegForm, "NBF_StoredActor_FactionIndex_List", Target, false)
			NBFMainScr.NBF_Log("[DetectNearbyEff] Adding Actor to Faction - " + akTarget.GetDisplayName() + " - " + NBFMainScr.BehaviourList[ArrayLength])
;			NBFMainScr.NBF_Log("[DetectNearbyEff] - " + akTarget.GetDisplayName() + " Aggression: " + akTarget.GetActorValue("Aggression"))
;			NBFMainScr.NBF_Log("[DetectNearbyEff] - " + akTarget.GetDisplayName() + " Confidence: " + akTarget.GetActorValue("Confidence"))
;			NBFMainScr.NBF_Log("[DetectNearbyEff] - " + akTarget.GetDisplayName() + " Morality: " + akTarget.GetActorValue("Morality"))
;			NBFMainScr.NBF_Log("[DetectNearbyEff] - " + akTarget.GetDisplayName() + " Assistance: " + akTarget.GetActorValue("Assistance"))
			
		endif
	endwhile
EndEvent

Event OnEffectFinish(Actor akTarget, Actor akCaster)
	Int FactionIndexArray = StorageUtil.IntListCount(NBFMainScr.NBFRegForm, "NBF_StoredActor_FactionIndex_" + akTarget)
	while FactionIndexArray > 0
		FactionIndexArray -= 1
		int FactionIndex = StorageUtil.IntListGet(NBFMainScr.NBFRegForm, "NBF_StoredActor_FactionIndex_" + akTarget, FactionIndexArray)
		StorageUtil.FormListRemove(NBFMainScr.NBFRegForm, "NBF_Actors_FactionIndex_" + FactionIndex, akTarget, true)
		StorageUtil.IntListRemove(NBFMainScr.NBFRegForm, "NBF_StoredActor_FactionIndex_" + akTarget, FactionIndexArray)
		NBFMainScr.NBF_Log("[DetectNearbyEff] Removing Actor - DeleteFactionIndex " + FactionIndex + " - " + akTarget.GetDisplayName())
	endwhile
	StorageUtil.FormListRemove(NBFMainScr.NBFRegForm, "NBF_StoredActor_FactionIndex_List", akTarget)
EndEvent