Scriptname _NBF_MCM extends SKI_ConfigBase

_NBF_MainScr Property NBFMainScr Auto

Int oidRegisterNPCs
Int oidClearAll
Int oidDespawnNPCs
Int oidRespawnDefaultNPCs

Int oidRespawnTimerBusy
Float Property RespawnTimerBusy = 24.0 Auto
Int oidRespawnTimerDead
Float Property RespawnTimerDead = 96.0 Auto
Int oidSpawnTimer
Float Property SpawnTimer = 24.0 Auto

String[] PageList

Int oidNPCListPage
Int Property NPCListPage Auto

Int oidEnableDebugLogging
Bool Property EnableDebugLogging = True Auto

Int oidSelectActorKey
Int Property SelectActorKey = 199 Auto
Actor Property SelectedActor Auto
String SelectedActorHexID
String SelectedActorModName
String[] FileList
Int oidOpenFile
String Property OpenedFile Auto
Int oidCreateNewFile
String Property NewFile Auto
Int oidAddActorToFile
Int oidRemoveActorFromFile
String Property RemovingActor Auto
String[] ActorsInFile

Event OnConfigInit()
	Pages = new string[4]
	Pages[0] = "General"
	Pages[1] = "NPCs"
	Pages[2] = "NPC Info"
	Pages[3] = "Register NPC"
	
	NBFMainScr.RegisterKeys()
EndEvent

Event OnPageReset(string a_page)
	if a_page == "General"
		SetCursorFillMode(TOP_TO_BOTTOM)
		oidRegisterNPCs = AddTextOption("Register NPCs", "Click")
		oidDespawnNPCs = AddTextOption("Despawn NPCs", "Click")
		oidRespawnDefaultNPCs = AddTextOption("Respawn original NPCs", "Click")
		oidClearAll = AddTextOption("Clear All", "Click")
		SetCursorPosition(1)
		oidSpawnTimer = AddSliderOption("Spawn Timer", SpawnTimer, "{1}")
		oidRespawnTimerBusy = AddSliderOption("Re-spawn Timer", RespawnTimerBusy, "{1}")
		oidRespawnTimerDead = AddSliderOption("Re-spawn Timer(Dead)", RespawnTimerDead, "{1}")
		oidEnableDebugLogging = AddToggleOption("Enable Logging", EnableDebugLogging)
	elseif a_page == "NPCs"
		oidNPCListPage = AddMenuOption("Show Page", "Page " + (NPCListPage + 1))
		AddEmptyOption()
		AddEmptyOption()
		AddEmptyOption()
		Int ArrayLength = StorageUtil.StringListCount(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_Name")
		Int ShowArrayStart = NPCListPage * 10
		Int ShowArrayMax = ShowArrayStart + 10
;		Int TempIndex = ArrayLength
;		While TempIndex > 0
;			TempIndex -= 1
		While (ShowArrayStart < ShowArrayMax) && (ShowArrayStart < ArrayLength)
			ShowArrayStart += 1
;			String TempNPCName = StorageUtil.StringListGet(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_Name", TempIndex)
			String TempNPCName = StorageUtil.StringListGet(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_Name", ShowArrayStart - 1)
			String TempNPCMod = StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName)
			Int TempOid
			Int TempOid2
			Int TempOid3
			Int TempOid4
			AddHeaderOption(TempNPCName + " (" + TempNPCMod + ") " + StorageUtil.GetIntValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName))
			TempOid2 = AddSliderOption(TempNPCName + " (Spawn Chance)", StorageUtil.GetIntValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName), "{0}%")
			StorageUtil.IntListAdd(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_MCM_Oid2", TempOid2, false)
			StorageUtil.SetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid2_" + TempOid2, TempNPCName)
			TempOid = AddMenuOption(TempNPCName + " Behaviour: ", StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName))
			StorageUtil.IntListAdd(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_MCM_Oid", TempOid, false)
			StorageUtil.SetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid_" + TempOid, TempNPCName)
			TempOid3 = AddMenuOption(TempNPCName + " Package: ", StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName))
			StorageUtil.IntListAdd(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_MCM_Oid3", TempOid3, false)
			StorageUtil.SetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid3_" + TempOid3, TempNPCName)
			TempOid4 = AddToggleOption(TempNPCName + " Allow Dispawn: ", StorageUtil.GetIntValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) as Bool)
			StorageUtil.IntListAdd(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_MCM_Oid4", TempOid4, false)
			StorageUtil.SetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid4_" + TempOid4, TempNPCName)
			AddEmptyOption()
			AddEmptyOption()
			AddEmptyOption()
		endwhile
	elseif a_page == "NPC Info"
		Int ArrayLength = StorageUtil.StringListCount(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_Name")
		Int TempIndex = ArrayLength
		While TempIndex > 0
			TempIndex -= 1
			String TempNPCName = StorageUtil.StringListGet(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_Name", TempIndex)
			Int TempInt = StorageUtil.GetIntValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName)
			String TempModName = StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName)
			Int TempNPCID = StorageUtil.GetIntValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCIDByNPCName_" + TempNPCName)
			ActorBase TempActorBase = Game.GetFormFromFile(TempNPCID, TempModName) as ActorBase
			if StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCNameByBaseID_" + TempActorBase.GetFormID()) == TempNPCName
				String TempStatus
				if TempInt == 0
					TempStatus = "Available"
				elseif TempInt == 1
					TempStatus = "Spawned"
				elseif TempInt == 2
					TempStatus = "Dead"
				else
					TempStatus = "Undefined"
				endif
				AddHeaderOption(TempNPCName + " - " + TempStatus)
			else
				AddHeaderOption("Can't find actor " + TempNPCName)
				AddHeaderOption("Please register NPCs again")
			endif
		endwhile
	elseif a_page == "Register NPC"
		SetCursorFillMode(TOP_TO_BOTTOM)
		oidSelectActorKey = AddKeyMapOption("Actor Selection Key", SelectActorKey)
		AddEmptyOption()
		AddHeaderOption("Selected Actor: " + SelectedActor.GetDisplayName())
		AddHeaderOption("BaseID: " + NBFMainScr.CustomRegGetNPCBaseID(SelectedActor))
		AddHeaderOption("BaseIDHex: " + NBFMainScr.GetBaseIDInHex(NBFMainScr.ConvertStringHexToStringHex2Comp(NBFMainScr.ConvertIntToHex(NBFMainScr.CustomRegGetNPCBaseID(SelectedActor)))))
		AddHeaderOption("Mod: " + NBFMainScr.GetModNameByHexIndex(NBFMainScr.GetModIndexInHex(NBFMainScr.ConvertStringHexToStringHex2Comp(NBFMainScr.ConvertIntToHex(NBFMainScr.CustomRegGetNPCBaseID(SelectedActor))))))
		SetCursorPosition(1)
		oidOpenFile = AddMenuOption("Select File", OpenedFile)
		oidCreateNewFile = AddInputOption("Create New File ", NewFile)
		oidAddActorToFile = AddTextOption("Save Actor to File", "Click")
		oidRemoveActorFromFile = AddMenuOption("Delete Actor from File", RemovingActor)
	endif
EndEvent

Event OnOptionKeyMapChange(Int Option, Int keyCode, String conflictControl, String conflictName)
	If Option == oidSelectActorKey
		SelectActorKey = keyCode	
		SetKeymapOptionValue(Option, keyCode)
		NBFMainScr.RegisterKeys()
	Endif		
EndEvent

Event OnOptionInputOpen(int option)
    if option == oidCreateNewFile
        SetInputDialogStartText(NewFile)
	endif
EndEvent

Event OnOptionInputAccept(int option, string Iinput)
	if option == oidCreateNewFile
		NewFile = Iinput
;		JsonUtil.StringListAdd("../NBF/NPC/" + NewFile, "A", "1")
		String[] EmptyString
		JsonUtil.SetPathStringArray("../NBF/NPC/" + NewFile, ".NBF_RegisterNPC", EmptyString)
		JsonUtil.Save("../NBF/NPC/" + NewFile)
		SetInputOptionValue(oidCreateNewFile, NewFile)
		ForcePageReset()
	endif
EndEvent

Event OnOptionSelect(Int Option)
	if (CurrentPage == "General")
		if Option == oidRegisterNPCs
			NBFMainScr.RegisterNPCs()
		elseif Option == oidClearAll
			NBFMainScr.ClearAll()
		elseif Option == oidDespawnNPCs
			NBFMainScr.DespawnNPCs()
		elseif Option == oidRespawnDefaultNPCs
			NBFMainScr.TryToRespawnDefaultActors()
		elseif Option == oidEnableDebugLogging
			EnableDebugLogging = !EnableDebugLogging
			SetToggleOptionValue(oidEnableDebugLogging, EnableDebugLogging)
		endif
	elseif (CurrentPage == "NPCs")
		if StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid4_" + Option)
			String TempNPCName = StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid4_" + Option)
			if StorageUtil.GetIntValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) == 1
				StorageUtil.SetIntValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 0)
			else
				StorageUtil.SetIntValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1)
			endif
			ForcePageReset()
		endif
	elseif (CurrentPage == "Register NPC")
		if Option == oidAddActorToFile
			if SelectedActor
				if OpenedFile
					String SelectedActorName = SelectedActor.GetDisplayName()
					String[] NPCList = JsonUtil.PathStringElements("../NBF/NPC/" + OpenedFile, ".NBF_RegisterNPC")
					if NPCList.Find(SelectedActorName) == -1
						StorageUtil.StringListCopy(none, "NBF_tempData", NPCList)
						Int ArrayLength = StorageUtil.StringListCount(none, "NBF_tempData")
						While ArrayLength > 0
							ArrayLength -= 1
							String TempNPCName = StorageUtil.StringListGet(none, "NBF_tempData", ArrayLength)
							String TempModName = JsonUtil.GetPathStringValue("../NBF/NPC/" + OpenedFile, "." + TempNPCName + "_ModName")
;							Int TempNPCID = JsonUtil.GetPathIntValue("../NBF/NPC/" + OpenedFile, "." + TempNPCName + "_ID")
							String TempNPCID = JsonUtil.GetPathStringValue("../NBF/NPC/" + OpenedFile, "." + TempNPCName + "_ID")
							StorageUtil.StringListSet(none, "NBF_tempData_TempModName", ArrayLength, TempModName)
;							StorageUtil.IntListSet(none, "NBF_tempData_TempNPCID", ArrayLength, TempNPCID)
							StorageUtil.StringListSet(none, "NBF_tempData_TempNPCID", ArrayLength, TempNPCID)
						endwhile
						JsonUtil.ClearAll("../NBF/NPC/" + OpenedFile)
						StorageUtil.StringListAdd(none, "NBF_tempData", SelectedActorName)
						String[] NewNPCList = StorageUtil.StringListToArray(none, "NBF_tempData")
						JsonUtil.SetPathStringArray("../NBF/NPC/" + OpenedFile, ".NBF_RegisterNPC", NewNPCList)
						ArrayLength = StorageUtil.StringListCount(none, "NBF_tempData")
						While ArrayLength > 0
							ArrayLength -= 1
							String TempNPCName = StorageUtil.StringListGet(none, "NBF_tempData", ArrayLength)
							String TempModName = StorageUtil.StringListGet(none, "NBF_tempData_TempModName", ArrayLength)
;							Int TempNPCID = StorageUtil.IntListGet(none, "NBF_tempData_TempNPCID", ArrayLength)
							String TempNPCID = StorageUtil.StringListGet(none, "NBF_tempData_TempNPCID", ArrayLength)
							JsonUtil.SetPathStringValue("../NBF/NPC/" + OpenedFile, "." + TempNPCName + "_ModName", TempModName)
;							JsonUtil.SetPathIntValue("../NBF/NPC/" + OpenedFile, "." + TempNPCName + "_ID", TempNPCID)
							JsonUtil.SetPathStringValue("../NBF/NPC/" + OpenedFile, "." + TempNPCName + "_ID", TempNPCID)
						endwhile
						JsonUtil.SetPathStringValue("../NBF/NPC/" + OpenedFile, "." + SelectedActorName + "_ModName", NBFMainScr.GetModNameByHexIndex(NBFMainScr.GetModIndexInHex(NBFMainScr.ConvertStringHexToStringHex2Comp(NBFMainScr.ConvertIntToHex(NBFMainScr.CustomRegGetNPCBaseID(SelectedActor))))))
;						JsonUtil.SetPathIntValue("../NBF/NPC/" + OpenedFile, "." + SelectedActorName + "_ID", NBFMainScr.CustomRegGetNPCBaseID(SelectedActor))
						JsonUtil.SetPathStringValue("../NBF/NPC/" + OpenedFile, "." + SelectedActorName + "_ID", NBFMainScr.GetBaseIDInHex(NBFMainScr.ConvertStringHexToStringHex2Comp(NBFMainScr.ConvertIntToHex(NBFMainScr.CustomRegGetNPCBaseID(SelectedActor)))))
						JsonUtil.Save("../NBF/NPC/" + OpenedFile)
						StorageUtil.StringListClear(none, "NBF_tempData")
						StorageUtil.StringListClear(none, "NBF_tempData_TempModName")
						StorageUtil.IntListClear(none, "NBF_tempData_TempNPCID")
						StorageUtil.StringListClear(none, "NBF_tempData_TempNPCID")
					else
						debug.messagebox("Actor is already saved")
					endif
				else
					debug.messagebox("No file selected")
				endif
			else
				debug.messagebox("No actor selected")
			endif
		endif
	endif
EndEvent

Event OnOptionMenuOpen(int opt)
	if (CurrentPage == "General")
		
	elseif (CurrentPage == "NPCs")
;		if StorageUtil.IntListFind(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_MCM_Oid", opt) != -1
		if StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid_" + opt)
			String TempNPCName = StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid_" + opt)
			Int TempIndex = NBFMainScr.BehaviourList.Find(StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName))
			SetMenuDialogStartIndex(TempIndex)
			SetMenuDialogDefaultIndex(-1)
			SetMenuDialogOptions(NBFMainScr.BehaviourList)
		elseif StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid3_" + opt)
			String TempNPCName = StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid3_" + opt)
;			debug.messagebox("OnOptionMenuOpen - TempNPCName: " + TempNPCName)
			Int TempIndex = NBFMainScr.GetSetNameByBehavior(StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName)).Find(StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName))
;			debug.messagebox("OnOptionMenuOpen - TempIndex: " + TempIndex)
			SetMenuDialogStartIndex(TempIndex)
			SetMenuDialogDefaultIndex(-1)
			SetMenuDialogOptions(NBFMainScr.GetSetNameByBehavior(StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName)))
		elseif opt == oidNPCListPage
			Int ArrayLength = StorageUtil.StringListCount(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_Name")
			Int NumPages = 0
			If ArrayLength <= 10
				NumPages = 1
			else
				While ArrayLength > 0
					ArrayLength -= 10
					NumPages += 1
				endwhile
			endif
			StorageUtil.StringListClear(NBFMainScr.NBFRegForm, "NBF_TempData_MCM_1")
			StorageUtil.StringListResize(NBFMainScr.NBFRegForm, "NBF_TempData_MCM_1", NumPages)
			While NumPages > 0
				NumPages -= 1
				StorageUtil.StringListSet(NBFMainScr.NBFRegForm, "NBF_TempData_MCM_1", NumPages, "Page " + (NumPages + 1))
			endwhile
			PageList = StorageUtil.StringListToArray(NBFMainScr.NBFRegForm, "NBF_TempData_MCM_1")
			SetMenuDialogStartIndex(NPCListPage)
			SetMenuDialogDefaultIndex(0)
			SetMenuDialogOptions(PageList)
		endif
	elseif (CurrentPage == "Register NPC")
		if opt == oidOpenFile
			FileList = MiscUtil.FilesInFolder("Data/SKSE/Plugins/NBF/NPC", ".json")
			SetMenuDialogStartIndex(FileList.Find(OpenedFile))
			SetMenuDialogDefaultIndex(0)
			SetMenuDialogOptions(FileList)
		elseif opt == oidRemoveActorFromFile
			if OpenedFile
				ActorsInFile = JsonUtil.PathStringElements("../NBF/NPC/" + OpenedFile, ".NBF_RegisterNPC")
				SetMenuDialogStartIndex(-1)
				SetMenuDialogDefaultIndex(-1)
				SetMenuDialogOptions(ActorsInFile)
			else
				debug.messagebox("No file selected")
			endif
		endif
	endif
EndEvent

Event OnOptionMenuAccept(int opt, int index)
	if (CurrentPage == "General")
		
	elseif (CurrentPage == "NPCs")
		if StorageUtil.IntListFind(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_MCM_Oid", opt) != -1
			if index == -1
				String TempNPCName = StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid_" + opt)
				String TempBehavior = StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName)
				StorageUtil.UnSetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName)
				StorageUtil.StringListRemove(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_MPCName_ByBehavior" + TempBehavior, TempNPCName)
				StorageUtil.IntListClear(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_MCM_Oid")
				StorageUtil.UnSetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid_" + opt)
				StorageUtil.UnSetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName) ; CHECK
			else
				String TempNPCName = StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid_" + opt)
				String PrevBehavior = StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName)
				StorageUtil.SetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName, NBFMainScr.BehaviourList[index])
				StorageUtil.StringListRemove(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_MPCName_ByBehavior" + PrevBehavior, TempNPCName)
				StorageUtil.StringListAdd(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_MPCName_ByBehavior" + NBFMainScr.BehaviourList[index], TempNPCName, false)
				StorageUtil.IntListClear(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_MCM_Oid")
				StorageUtil.UnSetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid_" + opt)
				if PrevBehavior != NBFMainScr.BehaviourList[index]
					StorageUtil.UnSetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName) ; CHECK
				endif
				SetMenuOptionValue(opt, NBFMainScr.BehaviourList[index])
			endif
			ForcePageReset()
		elseif StorageUtil.IntListFind(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_MCM_Oid3", opt) != -1
			if index == -1
				String TempNPCName = StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid3_" + opt)
				StorageUtil.UnSetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
				StorageUtil.IntListClear(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_MCM_Oid3")
				StorageUtil.UnSetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid3_" + opt)
				SetMenuOptionValue(opt, NBFMainScr.GetSetNameByBehavior(StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName))[index])
			else
				String TempNPCName = StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid3_" + opt)
				StorageUtil.SetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName, NBFMainScr.GetSetNameByBehavior(StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName))[index])
				StorageUtil.IntListClear(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_MCM_Oid3")
				StorageUtil.UnSetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid3_" + opt)
				SetMenuOptionValue(opt, NBFMainScr.GetSetNameByBehavior(StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName))[index])
			endif
			ForcePageReset()
		elseif (opt == oidNPCListPage)
			NPCListPage = index
			SetMenuOptionValue(opt, PageList[NPCListPage])
			ForcePageReset()
		endif
	elseif (CurrentPage == "Register NPC")
		if opt == oidOpenFile
			OpenedFile = FileList[Index]
			SetMenuOptionValue(opt, OpenedFile)
			ForcePageReset()
		elseif opt == oidRemoveActorFromFile
			if Index == -1
				return
			endif
			RemovingActor = ActorsInFile[Index]
			String[] NPCList = JsonUtil.PathStringElements("../NBF/NPC/" + OpenedFile, ".NBF_RegisterNPC")
			StorageUtil.StringListCopy(none, "NBF_tempData", NPCList)
			StorageUtil.StringListRemove(none, "NBF_tempData", RemovingActor)
			Int ArrayLength = StorageUtil.StringListCount(none, "NBF_tempData")
			While ArrayLength > 0
				ArrayLength -= 1
				String TempNPCName = StorageUtil.StringListGet(none, "NBF_tempData", ArrayLength)
				String TempModName = JsonUtil.GetPathStringValue("../NBF/NPC/" + OpenedFile, "." + TempNPCName + "_ModName")
;				Int TempNPCID = JsonUtil.GetPathIntValue("../NBF/NPC/" + OpenedFile, "." + TempNPCName + "_ID")
				String TempNPCID = JsonUtil.GetPathStringValue("../NBF/NPC/" + OpenedFile, "." + TempNPCName + "_ID")
				StorageUtil.StringListSet(none, "NBF_tempData_TempModName", ArrayLength, TempModName)
;				StorageUtil.IntListSet(none, "NBF_tempData_TempNPCID", ArrayLength, TempNPCID)
				StorageUtil.StringListSet(none, "NBF_tempData_TempNPCID", ArrayLength, TempNPCID)
			endwhile
			JsonUtil.ClearAll("../NBF/NPC/" + OpenedFile)
			String[] NewNPCList = StorageUtil.StringListToArray(none, "NBF_tempData")
			JsonUtil.SetPathStringArray("../NBF/NPC/" + OpenedFile, ".NBF_RegisterNPC", NewNPCList)
			ArrayLength = StorageUtil.StringListCount(none, "NBF_tempData")
			While ArrayLength > 0
				ArrayLength -= 1
				String TempNPCName = StorageUtil.StringListGet(none, "NBF_tempData", ArrayLength)
				String TempModName = StorageUtil.StringListGet(none, "NBF_tempData_TempModName", ArrayLength)
;				Int TempNPCID = StorageUtil.IntListGet(none, "NBF_tempData_TempNPCID", ArrayLength)
				String TempNPCID = StorageUtil.StringListGet(none, "NBF_tempData_TempNPCID", ArrayLength)
				JsonUtil.SetPathStringValue("../NBF/NPC/" + OpenedFile, "." + TempNPCName + "_ModName", TempModName)
;				JsonUtil.SetPathIntValue("../NBF/NPC/" + OpenedFile, "." + TempNPCName + "_ID", TempNPCID)
				JsonUtil.SetPathStringValue("../NBF/NPC/" + OpenedFile, "." + TempNPCName + "_ID", TempNPCID)
			endwhile
			JsonUtil.Save("../NBF/NPC/" + OpenedFile)
			StorageUtil.StringListClear(none, "NBF_tempData")
			StorageUtil.StringListClear(none, "NBF_tempData_TempModName")
			StorageUtil.IntListClear(none, "NBF_tempData_TempNPCID")
			StorageUtil.StringListClear(none, "NBF_tempData_TempNPCID")
			
		endif
	endif
EndEvent

Event OnOptionSliderOpen(Int Option)
	If (CurrentPage == "General")
		If Option == oidSpawnTimer
			SetSliderDialogStartValue(SpawnTimer)
			SetSliderDialogDefaultValue(24.0)
			SetSliderDialogRange(0.5, 120.0)
			SetSliderDialogInterval(0.5)
		elseif Option == oidRespawnTimerBusy
			SetSliderDialogStartValue(RespawnTimerBusy)
			SetSliderDialogDefaultValue(24.0)
			SetSliderDialogRange(0.5, 120.0)
			SetSliderDialogInterval(0.5)
		elseif Option == oidRespawnTimerDead
			SetSliderDialogStartValue(RespawnTimerDead)
			SetSliderDialogDefaultValue(96.0)
			SetSliderDialogRange(0.5, 240.0)
			SetSliderDialogInterval(0.5)
		endif
	elseif (CurrentPage == "NPCs")
		if StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid2_" + Option)
			String TempNPCName = StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid2_" + Option)
			SetSliderDialogStartValue(StorageUtil.GetIntValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName))
			SetSliderDialogDefaultValue(1.0)
			SetSliderDialogRange(0.0, 100.0)
			SetSliderDialogInterval(1)
		endif
	endif
EndEvent

Event OnOptionSliderAccept(Int Option, Float Value)
	If (CurrentPage == "General")
		If Option == oidSpawnTimer
			SpawnTimer = Value
			SetSliderOptionValue(oidSpawnTimer, SpawnTimer, "{1}")
		elseif Option == oidRespawnTimerBusy
			RespawnTimerBusy = Value
			SetSliderOptionValue(oidRespawnTimerBusy, RespawnTimerBusy, "{1}")
		elseif Option == oidRespawnTimerDead
			RespawnTimerDead = Value
			SetSliderOptionValue(oidRespawnTimerDead, RespawnTimerDead, "{1}")
		endif
	elseif (CurrentPage == "NPCs")
		if StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid2_" + Option)
			String TempNPCName = StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid2_" + Option)
			StorageUtil.SetIntValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName, Value as int)
;			SetSliderOptionValue(Option, StorageUtil.GetIntValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName), "{0}%")
			StorageUtil.UnSetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid2_" + Option)
			StorageUtil.IntListClear(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCoid2")
			ForcePageReset()
		endif
	endif
EndEvent

Event OnOptionHighlight(Int Option)
	if CurrentPage == "General"
		if Option == oidRegisterNPCs
			SetInfoText("Register NPCs.")
		elseif Option == oidClearAll
			SetInfoText("Delete mod related data.")
		elseif Option == oidDespawnNPCs
			SetInfoText("Clear all spawned NPCs.")
		elseif Option == oidRespawnDefaultNPCs
			SetInfoText("Try to respawn original followers at their editor locations.")
		elseif Option == oidSpawnTimer
			SetInfoText("How many in-game hours must pass before another NPC of the same behavior can be spawned.")
		elseif Option == oidRespawnTimerBusy
			SetInfoText("How manu in-game hours must pass before existing NPC can respawn in a different place.")
		elseif Option == oidRespawnTimerDead
			SetInfoText("How many in-game hours must pass before dead NPC can respawn.")
		elseif Option == oidEnableDebugLogging
			SetInfoText("Enable logging for debuging.")
		endif
	elseif CurrentPage == "Register NPC"
		if Option == oidSelectActorKey
			SetInfoText("Pick a key used to select actors.")
		elseif Option == oidOpenFile
			SetInfoText("Pick a file with saved NPC data.")
		elseif Option == oidCreateNewFile
			SetInfoText("Create new file. Enter name of new file. For example, 'My NPC' or '333' without quotes.")
		elseif Option == oidAddActorToFile
			SetInfoText("Add selected actor to selected file.")
		elseif Option == oidRemoveActorFromFile
			SetInfoText("Remove selected actor from selected file.")
		endif
	endif
EndEvent