Scriptname _NBF_NPCAlias extends ReferenceAlias

Int Property TestInt Auto

_NBF_MainScr Property NBFMainScr Auto
Actor NPC

String Property Behavior Auto
String Property SubPackageName Auto
Int Property SubPackageIndex = -1 Auto

Function Init()
	NPC = Self.GetActorReference()
	NBFMainScr.NBF_Log("_NBF_NPCAlias - Init - " + NPC.GetDisplayName())
	if NPC.Is3DLoaded()
		NPC.Enable()
	endif
;	_LRG_HealerAI_MainScr HealerScr = Quest.GetQuest("_LRG_Healer_Main") as _LRG_HealerAI_MainScr
;	ReferenceAlias TempAlias = HealerScr.AddHealer(NPC)
;	HealerScr.SetHealerFaction(TempAlias, NBFMainScr.GuardFaction)
;	HealerScr.SetHealerMaxMagicka(TempAlias, 150)
;	HealerScr.AddHealerSpell(TempAlias, "Heal Ally Conc A")
;	HealerScr.AddHealerSpell(TempAlias, "Heal Cloak Self A")
	RegisterForSingleUpdate(1.0)
EndFunction

Event OnDeath(Actor akKiller)
	NBFMainScr.NBF_Log("_NBF_NPCAlias - OnDeath" +  NPC.GetDisplayName())
	String TempNPCName = StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCNameByBaseID_" + NPC.GetActorBase().GetFormID())
	StorageUtil.SetIntValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 2)
	StorageUtil.SetFloatValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName, Utility.GetCurrentGameTime())
	Behavior = ""
	SubPackageName = ""
	SubPackageIndex = -1
	NPC.GetActorBase().SetEssential(1)
	Self.Clear()
EndEvent

Event OnUpdate()
	NBFMainScr.NBF_Log("_NBF_NPCAlias - OnUpdate" +  NPC.GetDisplayName())
	if NPC.Is3DLoaded()
		NBFMainScr.NBF_Log("_NBF_NPCAlias - OnUpdate" +  NPC.GetDisplayName() + " 3D Loaded")
	else
		NBFMainScr.NBF_Log("_NBF_NPCAlias - OnUpdate" +  NPC.GetDisplayName() + " 3D Not Loaded")
	endif
	if !NPC.IsDisabled()
		NBFMainScr.NBF_Log("_NBF_NPCAlias - OnUpdate" +  NPC.GetDisplayName() + " Enabled")
	else
		NBFMainScr.NBF_Log("_NBF_NPCAlias - OnUpdate" +  NPC.GetDisplayName() + " Disabled")
	endif
	NBFMainScr.NBF_Log("_NBF_NPCAlias - OnUpdate - Behavior: " + Behavior)
	NBFMainScr.NBF_Log("_NBF_NPCAlias - OnUpdate - SubPackageName: " + SubPackageName)
	NBFMainScr.NBF_Log("_NBF_NPCAlias - OnUpdate - SubPackageIndex: " + SubPackageIndex)
	NBFMainScr.NBF_Log("_NBF_NPCAlias - OnUpdate" +  NPC.GetDisplayName() + " Disatnce from Player: " + NPC.GetDistance(NBFMainScr.PlayerRef))
	if Self.GetActorReference()
		NBFMainScr.NBF_Log("_NBF_NPCAlias - OnUpdate - Self: " + Self.GetActorReference())
		RegisterForSingleUpdate(10.0)
	endif
EndEvent

Event OnEnterBleedout()
	NBFMainScr.NBF_Log("_NBF_NPCAlias - OnEnterBleedout" +  NPC.GetDisplayName())
	if NPC.GetActorBase().IsEssential()
		GoToState("Bleeding")
	endif
endEvent

Event OnLoad()
	NPC.SetRelationshipRank(NBFMainScr.PlayerRef, 0)
	NBFMainScr.NBF_Log("_NBF_NPCAlias - OnLoad" +  NPC.GetDisplayName())
EndEvent

Event OnUnLoad()
	NBFMainScr.NBF_Log("_NBF_NPCAlias - OnUnLoad" +  NPC.GetDisplayName())
EndEvent

Function TestIntFunction()
;	NBFMainScr.NBF_Log(NPC.GetDisplayName() + " - " + PackageSetName)
EndFunction

State Bleeding

	Event OnBeginState()
		RegisterForSingleUpdate(0.5)
	EndEvent
	
	Event OnUpdate()
		if !NPC.Isbleedingout()
			GoToState("")
		else
			RegisterForSingleUpdate(0.5)
		endif
	EndEvent
	
	Event onEndState()
	EndEvent
	
	Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
		if NPC.IsbleedingOut()
			if NPC.GetActorBase().IsEssential()
				NPC.GetActorBase().SetEssential(0)
				NPC.Kill()
			endif
		endif
	EndEvent
	
	Event OnDeath(Actor akKiller)
		NBFMainScr.NBF_Log("_NBF_NPCAlias - OnDeath" +  NPC.GetDisplayName())
		String TempNPCName = StorageUtil.GetStringValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCNameByBaseID_" + NPC.GetActorBase().GetFormID())
		StorageUtil.SetIntValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 2)
		StorageUtil.SetFloatValue(NBFMainScr.NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName, Utility.GetCurrentGameTime())
		Behavior = ""
		SubPackageName = ""
		SubPackageIndex = -1
		NPC.GetActorBase().SetEssential(1)
		Self.Clear()
	EndEvent
	
EndState