Scriptname _NBF_MainScr extends Quest

Actor Property PlayerRef Auto
_NBF_MCM Property MCM Auto
_NBF_PackageStorageScr Property PackageStorage Auto
Form Property NBFRegForm Auto
ReferenceAlias[] Property NPCAlias Auto
ObjectReference Property NBFRegObjRef Auto

Faction Property CurrentFollowerFaction Auto
Faction Property PotentialFollowerFaction Auto
Faction Property PotentialMarriageFaction Auto
Faction Property Playerfaction Auto
Faction Property GuardFaction Auto
Faction Property GuardDialogueFaction Auto
Faction Property CrimeFactionWhiterun Auto
Faction Property CrimeFactionDawnstar Auto
Faction Property CrimeFactionFalkreath Auto
Faction Property CrimeFactionMarkarth Auto
Faction Property CrimeFactionRiften Auto
Faction Property CrimeFactionSolitude Auto
Faction Property CrimeFactionWindhelm Auto
Faction Property CrimeFactionWinterhold Auto
Faction Property CrimeFactionMorthal Auto

Faction[] Property FactionList Auto
; 0 - Bandit
; 1 - Forsworn
; 2 - Vampire
; 3 - Necromancer
; 4 - Warlock
; 5 - Imperial Solder
; 6 - Stormcloack Solder
; 7 - Guard(Whiterun)
; 8 - Guard(Dawnstar)
; 9 - Guard(Falkreath)
; 10 - Guard(Markarth)
; 11 - Guard(Morthal)
; 12 - Guard(Riften)
; 13 - Guard(Solitude)
; 14 - Guard(Windhelm)
; 15 - Guard(Winterhold)
; 16 - Guard(CidhnaMine)

Location CurrentLocation
Int CurrentLocationType = -1

String[] Property BehaviourList Auto
; 0 - Bandit
; 1 - Forsworn
; 2 - Vampire
; 3 - Necromancer
; 4 - Warlock
; 5 - Imperial Solder
; 6 - Stormcloack Solder
; 7 - Guard(Whiterun)
; 8 - Guard(Dawnstar)
; 9 - Guard(Falkreath)
; 10 - Guard(Markarth)
; 11 - Guard(Morthal)
; 12 - Guard(Riften)
; 13 - Guard(Solitude)
; 14 - Guard(Windhelm)
; 15 - Guard(Winterhold)
; 16 - Guard(CidhnaMine)

Spell Property DetectCloakSpell Auto
Spell Property ChangeCellSpell Auto

Event OnInit()
	PlayerRef.AddSpell(DetectCloakSpell, True)
	PlayerRef.AddSpell(ChangeCellSpell, True)
;	RegisterForModEvent("Leash_PlayerChangeCell", "OnLeash_PlayerChangeCell")
	RegisterForModEvent("NBF_PlayerChangeCell", "OnNBF_PlayerChangeCell")
	RegisterPatrolMarkers()
	NBFRegForm = NBFRegObjRef
EndEvent

Function RegisterKeys()
	RegisterForKey(MCM.SelectActorKey)
EndFunction

Event OnKeyDown(Int KeyCode)	
	If KeyCode == MCM.SelectActorKey
		ObjectReference TempObj = Game.GetCurrentCrosshairRef()
		if (TempObj as Actor)
			MCM.SelectedActor = TempObj as Actor
		endif
	endif
EndEvent

Int Function CustomRegGetNPCBaseID(actor TargetActor)
	NBF_Log("[NBF_Test] - CustomRegGetNPCBaseID " + TargetActor)
	Int TempInt = TargetActor.GetActorBase().GetFormID()
	NBF_Log("[NBF_Test] - CustomRegGetNPCBaseID TempInt: " + TempInt)
	return TempInt
EndFunction

; Disclaimer: ConvertIntToHex() is a copy of function created by Ed86 (https://www.loverslab.com/profile/388097-ed86/)
; Source: function DectoHex() in script "SLSO_MCM.psc" of mod "SexLab Separate Orgasm LE.esp" (https://www.loverslab.com/files/file/3736-sexlab-separate-orgasm-le/)

String Function ConvertIntToHex(int TargetInt)
	NBF_Log("[NBF_Test] - ConvertIntToHex " + TargetInt)
    String digits = "0123456789ABCDEF"
    int base = 16
    String hex = ""
	
	if (TargetInt <= 0)
		return 0
	endif
	
    while (TargetInt > 0)
        int digit = TargetInt % base
;		NBF_Log("[NBF_Test] - ConvertIntToHex - digit " + digit)
        hex = StringUtil.GetNthChar(digits, digit) + hex
;		NBF_Log("[NBF_Test] - ConvertIntToHex - hex " + hex)
        TargetInt = TargetInt / base
;		NBF_Log("[NBF_Test] - ConvertIntToHex - TargetInt " + TargetInt)
	endwhile
	NBF_Log("[NBF_Test] - ConvertIntToHex - hex " + hex)
    return hex
EndFunction

Int Function StringHexToInt(String TargetHex)
	NBF_Log("[NBF_Test] - StringHexToInt - TargetHex " + TargetHex)
	String[] Digits = New String[16]
	Digits[0] = "0"
	Digits[1] = "1"
	Digits[2] = "2"
	Digits[3] = "3"
	Digits[4] = "4"
	Digits[5] = "5"
	Digits[6] = "6"
	Digits[7] = "7"
	Digits[8] = "8"
	Digits[9] = "9"
	Digits[10] = "A"
	Digits[11] = "B"
	Digits[12] = "C"
	Digits[13] = "D"
	Digits[14] = "E"
	Digits[15] = "F"
	
	Int Value
	Int NumberOfDigits = StringUtil.GetLength(TargetHex)
	Int DigitIndex = 0
	NBF_Log("[NBF_Test] - StringHexToInt - NumberOfDigits " + NumberOfDigits)
	While NumberOfDigits > DigitIndex
		Value += (Digits.Find(StringUtil.GetNthChar(TargetHex, DigitIndex)) * Math.Pow(16, (NumberOfDigits - DigitIndex - 1))) as int
		NBF_Log("[NBF_Test] - StringHexToInt - Value " + Value)
		NBF_Log("[NBF_Test] - StringHexToInt - DigitIndex " + DigitIndex)
		DigitIndex += 1
	endwhile
	NBF_Log("[NBF_Test] - StringHexToInt - Value " + Value)
	return Value
EndFunction

String Function GetModIndexInHex(String TargetHex)
	NBF_Log("[NBF_Test] - GetModIndexInHex - TargetHex " + TargetHex)
	String Index = StringUtil.GetNthChar(TargetHex, 0) + StringUtil.GetNthChar(TargetHex, 1)
	NBF_Log("[NBF_Test] - GetModIndexInHex - Index " + Index)
	return Index
EndFunction

; Return BaseID in hex witout modID
String Function GetBaseIDInHex(String TargetHex)
	NBF_Log("[NBF_Test] - GetModIndexInHex - TargetHex " + TargetHex)
	Int ArrayLength = StringUtil.GetLength(TargetHex)
	String Hex
	if ArrayLength == 8
		Hex = StringUtil.GetNthChar(TargetHex, 2) + StringUtil.GetNthChar(TargetHex, 3) + StringUtil.GetNthChar(TargetHex, 4) + StringUtil.GetNthChar(TargetHex, 5) + StringUtil.GetNthChar(TargetHex, 6) + StringUtil.GetNthChar(TargetHex, 7)
		NBF_Log("[NBF_Test] - GetModIndexInHex - Hex " + Hex)
		return Hex
	elseif ArrayLength == 7
		Hex = StringUtil.GetNthChar(TargetHex, 1) + StringUtil.GetNthChar(TargetHex, 2) + StringUtil.GetNthChar(TargetHex, 3) + StringUtil.GetNthChar(TargetHex, 4) + StringUtil.GetNthChar(TargetHex, 5) + StringUtil.GetNthChar(TargetHex, 6)
		NBF_Log("[NBF_Test] - GetModIndexInHex - Hex " + Hex)
		return Hex
	endif
EndFunction

String Function GetModNameByHexIndex(String TargetHex)
	NBF_Log("[NBF_Test] - GetModNameByHexIndex - TargetHex " + TargetHex)
	String TempString = Game.GetModName(StringHexToInt(TargetHex))
	NBF_Log("[NBF_Test] - GetModNameByHexIndex - TempString " + TempString)
	return TempString
EndFunction

String Function ConvertStringHexToStringHex2Comp(String TargetHex)
	NBF_Log("[NBF_Test] - ConvertStringHexToStringHex2Comp - TargetHex " + TargetHex)
	Int StringLength = StringUtil.GetLength(TargetHex)
	if StringLength == 8
		NBF_Log("[NBF_Test] - ConvertStringHexToStringHex2Comp - Not needed")
		return TargetHex
	else
		Int Diff = (8 - StringLength)
		String NewString
		While Diff > 0
			Diff -= 1
			NewString += "0"
		endwhile
		NewString += TargetHex
		NBF_Log("[NBF_Test] - ConvertStringHexToStringHex2Comp - NewString: " + NewString)
		return NewString
	endif
EndFunction

Function RegisterNPCs()
	Int TempIndex = 0
	String[] TempStr = MiscUtil.FilesInFolder("Data/SKSE/Plugins/NBF/NPC", ".json")
	StorageUtil.StringListCopy(NBFRegForm, "NBF_ExternalNPCFileList", TempStr)
	Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_ExternalNPCFileList")
	While ArrayLength > 0
		ArrayLength -= 1
		String TempString = StorageUtil.StringListGet(NBFRegForm, "NBF_ExternalNPCFileList", ArrayLength)
		NBF_Log("[NBF_Test] " + TempString)
		String TempFileName = "../NBF/NPC/" + TempString
		String[] TempNpcList
		TempNpcList = JsonUtil.PathStringElements(TempFileName, ".NBF_RegisterNPC")
		StorageUtil.StringListCopy(NBFRegForm, "NBF_ExternalNPC_NPCList", TempNpcList)
		Int ArrayLength2 = StorageUtil.StringListCount(NBFRegForm, "NBF_ExternalNPC_NPCList")
		While ArrayLength2 > 0
			ArrayLength2 -= 1
			String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_ExternalNPC_NPCList", ArrayLength2)
			String TempModName = JsonUtil.GetPathStringValue(TempFileName, "." + TempNPCName + "_ModName")
;			Int TempNPCID = JsonUtil.GetPathIntValue(TempFileName, "." + TempNPCName + "_ID")
			String TempNPCIDStr = JsonUtil.GetPathStringValue(TempFileName, "." + TempNPCName + "_ID")
			Int TempNPCID = StringHexToInt(TempNPCIDStr)
			String TempOrigOutfitModName = JsonUtil.GetPathStringValue(TempFileName, "." + TempNPCName + "_OrigOutfit_ModName")
			Int TempOrigOutID = JsonUtil.GetPathIntValue(TempFileName, "." + TempNPCName + "_OrigOutfit_ID")
			NBF_Log("[NBF_Test] TempNPCName: " + TempNPCName)
			NBF_Log("[NBF_Test] TempModName: " + TempModName)
			NBF_Log("[NBF_Test] TempNPCIDStr: " + TempNPCIDStr)
			NBF_Log("[NBF_Test] TempNPCID: " + TempNPCID)
			if Game.GetModByName(TempModName) != 255
				NBF_Log("[NBF_Test] ModExists: " + TempModName)
				ActorBase TempActorBase = Game.GetFormFromFile(TempNPCID, TempModName) as ActorBase
				if TempActorBase
					StorageUtil.StringListAdd(NBFRegForm, "NBF_RegisteredNPC_Name", TempNPCName, false)
					StorageUtil.IntListAdd(NBFRegForm, "NBF_RegisteredNPCID", TempNPCID, false)
					StorageUtil.IntListAdd(NBFRegForm, "NBF_RegisteredNPCBaseID", TempActorBase.GetFormID(), false)
					StorageUtil.SetStringValue(NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName, TempModName)
					StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCIDByNPCName_" + TempNPCName, TempNPCID)
					StorageUtil.SetStringValue(NBFRegForm, "NBF_RegisteredNPC_NPCNameByID_" + TempNPCID, TempNPCName)
					StorageUtil.SetStringValue(NBFRegForm, "NBF_RegisteredNPC_NPCNameByBaseID_" + TempActorBase.GetFormID(), TempNPCName)
					StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0))
					StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName, StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName, 5))
				else
					Debug.Messagebox("ERROR: Can't find actor " + TempNPCName + " in mod " + TempModName)
				endif
			endif
			
		endwhile
	endwhile
	StorageUtil.StringListClear(NBFRegForm, "NBF_ExternalNPCFileList")
	StorageUtil.StringListClear(NBFRegForm, "NBF_ExternalNPC_NPCList")
	RegisterPatrolMarkers()
EndFunction

Function ClearAll()
	Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
	While ArrayLength > 0
		ArrayLength -= 1
		String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
		Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
		if TempActor
			FindEmptyAlias(TempActor, false)
			TempActor.Disable()
		endif
	endwhile
	StorageUtil.debug_DeleteValues(NBFRegForm)
EndFunction

Function DespawnNPCs()
	Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
	While ArrayLength > 0
		ArrayLength -= 1
		String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
		Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
		debug.messagebox("Disable: " + TempActor.GetDisplayName())
		RespawnDefaultActor(TempNPCName)
		if TempActor
			FindEmptyAlias(TempActor, false)
			TempActor.Disable()
			StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
			StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
			StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
			StorageUtil.UnSetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
		endif
	endwhile
	ArrayLength = 10
	While ArrayLength > 0
		ArrayLength -= 1
		StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_LastSpawnTime_" + ArrayLength)
	endwhile
EndFunction

Function TryToRespawnDefaultActors()
	Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
	While ArrayLength > 0
		ArrayLength -= 1
		String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
		if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 1) != 1
			RespawnDefaultActor(TempNPCName)
		endif
	endwhile
EndFunction

Function RespawnDefaultActor(String TargetName)
	if StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_DisabledActorByName_" + TargetName)
		NBF_Log("RespawnDefaultActor - " + TargetName)
		Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TargetName) as Actor
		Actor DefaultActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_DisabledActorByName_" + TargetName) as Actor
		StorageUtil.FormListRemove(NBFRegForm, "NBF_RegisteredNPC_SpawnedActorBaseList", TempActor.GetActorBase(), true)
		DefaultActor.SetFactionRank(PotentialFollowerFaction, 0)
		DefaultActor.SetFactionRank(CurrentFollowerFaction, -1)
		DefaultActor.SetFactionRank(PotentialMarriageFaction, 0)
		DefaultActor.SetRelationshipRank(PlayerRef, 3)
		Int ArrayLength2 = FactionList.Length
		while ArrayLength2 > 0
			ArrayLength2 -= 1
			if DefaultActor.GetFactionRank(FactionList[ArrayLength2]) >= 0
				DefaultActor.RemoveFromFaction(FactionList[ArrayLength2])
			endif
		endwhile
		DefaultActor.Enable()
		ActorUtil.ClearPackageOverride(DefaultActor)
		DefaultActor.EvaluatePackage()
		StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_DisabledActorByName_" + TargetName)
	endif
EndFunction

Bool ProcessBusy = False
Bool ProcessPending = False

Event OnLeash_PlayerChangeCell(string eventName, string strArg, float somefloat = 1.0, Form sender)
	if ProcessBusy
		ProcessPending = True
	else
		ProcessBusy = True
		RegisterForSingleUpdate(0.5)
	endif
EndEvent

Event OnNBF_PlayerChangeCell(string eventName, string strArg, float somefloat = 1.0, Form sender)
	if ProcessBusy
		ProcessPending = True
	else
		ProcessBusy = True
		RegisterForSingleUpdate(0.5)
	endif
EndEvent

Float LastTimeChecked = 0.0
Int RespawnTicks = 3

Event OnUpdate()
	NBF_Log("OnUpdate")
	ProcessBusy = True
	Float CurrentTime = Utility.GetCurrentGameTime()
	NBF_Log("CurrentTime: " + CurrentTime)
	NBF_Log("LastTimeChecked: " + LastTimeChecked)
	if (CurrentTime - LastTimeChecked) >= 0.007
		NBF_Log("OnUpdate - Checking")
		if RespawnTicks <= 0
			NBF_Log("OnUpdate - Respawn")
			RespawnTicks = 3
			if StorageUtil.FormListCount(NBFRegForm, "NBF_RegisteredNPC_SpawnedActorBaseList") > 0
				Int ArrayLength3 = StorageUtil.FormListCount(NBFRegForm, "NBF_RegisteredNPC_SpawnedActorBaseList")
				Int Index = 0
				While ArrayLength3 > Index
					ActorBase TempActorBase = StorageUtil.FormListGet(NBFRegForm, "NBF_RegisteredNPC_SpawnedActorBaseList", Index) as ActorBase
					String TempNPCName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_NPCNameByBaseID_" + TempActorBase.GetFormID())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, -1) == 1
						NBF_Log("OnUpdate - Respawn " + TempNPCName + " Busy")
						if !TempActor.Is3DLoaded() && (StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) == 1)
							if (CurrentTime - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerBusy
								StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
								if FindEmptyAlias(TempActor, false) >= 0
									NBF_Log("OnUpdate - Respawn " + TempNPCName + " Removed from Alias")
								else
									NBF_Log("OnUpdate - Respawn " + TempNPCName + " Not in Alias")
								endif
								RespawnDefaultActor(TempNPCName)
								TempActor.Disable()
								StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
								StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
								StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
								NBF_Log("OnUpdate - Respawn " + TempNPCName + " Set NPC Status to Ready")
							endif
						endif
					elseif StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, -1) == 2
						NBF_Log("OnUpdate - Respawn " + TempNPCName + " Dead")
						if !TempActor.Is3DLoaded()
							if (CurrentTime - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerDead
								StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
								if FindEmptyAlias(TempActor, false) >= 0
									NBF_Log("OnUpdate - Respawn " + TempNPCName + " Removed from Alias")
								else
									NBF_Log("OnUpdate - Respawn " + TempNPCName + " Not in Alias")
								endif
								RespawnDefaultActor(TempNPCName)
								TempActor.Disable()
								StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
								StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
								StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
								NBF_Log("OnUpdate - Respawn " + TempNPCName + " Set NPC Status to Ready")
							endif
						endif
					elseif StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, -1) == 0
						NBF_Log("OnUpdate - Respawn " + TempNPCName + " Ready")
						RespawnDefaultActor(TempNPCName)
					endif
					Index += 1
				endwhile
			endif
		else
			RespawnTicks -= 1
		endif
		LastTimeChecked = CurrentTime
		AliasMaintenance()
		Int ArrayLength = 7 ; starting with 6
		if StorageUtil.FormListCount(NBFRegForm, "NBF_StoredActor_FactionIndex_List") > 0
			While ArrayLength > 0
				ArrayLength -= 1
				NBF_Log("OnUpdate - Checking " + BehaviourList[ArrayLength])
				if (CurrentTime - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_LastSpawnTime_" + ArrayLength, 0)) * 24 >= MCM.SpawnTimer
					if StorageUtil.FormListCount(NBFRegForm, "NBF_Actors_FactionIndex_" + ArrayLength)
						Int ArrayLength2 = StorageUtil.FormListCount(NBFRegForm, "NBF_Actors_FactionIndex_" + ArrayLength)
						While ArrayLength2 > 0
							ArrayLength2 -= 1
							Actor TempActor = StorageUtil.FormListGet(NBFRegForm, "NBF_Actors_FactionIndex_" + ArrayLength, ArrayLength2) as Actor
							NBF_Log("OnUpdate - Checking - " + TempActor + " - " + TempActor.GetDisplayName())
							if TempActor && !TempActor.isDead() && !TempActor.IsDisabled() && TempActor.GetDistance(PlayerRef) >= 2000 && CheckFaction(TempActor, ArrayLength)
								NBF_Log("OnUpdate - Check Done - " + TempActor + " - " + TempActor.GetDisplayName())
								ActorBase TempActorBase = FindSuitableNPC(BehaviourList[ArrayLength])
								NBF_Log("OnUpdate - TempActorBase - " + TempActorBase)
								if TempActorBase != none
									Actor SpawnedActor = SpawnNPC(TempActor, TempActorBase)
									if SpawnedActor
										NBF_Log("OnUpdate - Spawning - " + SpawnedActor.GetDisplayName())
										PrepareSpawnedNPC(SpawnedActor, ArrayLength)
										StorageUtil.SetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + SpawnedActor.GetDisplayName(), CurrentTime)
										ArrayLength = 0
										ArrayLength2 = 0
									else
										NBF_Log("OnUpdate - Spawning - ERROR: Actor was not spawned")
									endif
								else
									ArrayLength = 0
								endif
							endif
						endwhile
					endif
				else
					NBF_Log("OnUpdate - Checking " + BehaviourList[ArrayLength] + " - Timer")
				endif
			endwhile
		endif
		
		ArrayLength = BehaviourList.Length
		While ArrayLength > 7 && ArrayLength < 18
			ArrayLength -= 1
			NBF_Log("OnUpdate - Checking " + BehaviourList[ArrayLength])
			StorageUtil.IntListClear(NBFRegForm, "NBF_BlockSubPackageProcessingByIndex_" + BehaviourList[ArrayLength])
			if (CurrentTime - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_LastSpawnTime_" + ArrayLength, 0)) * 24 >= MCM.SpawnTimer
				if StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_MPCName_ByBehavior" + BehaviourList[ArrayLength]) > 0
					Int ArrayLength2 = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_MPCName_ByBehavior" + BehaviourList[ArrayLength])
					While ArrayLength2 > 0
						ArrayLength2 -= 1
						String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_MPCName_ByBehavior" + BehaviourList[ArrayLength], ArrayLength2)
						NBF_Log("OnUpdate - Checking - " + TempNPCName)
						ActorBase TempActorBase =  FindSuitableNPC(BehaviourList[ArrayLength], TempNPCName)
						if TempActorBase != none
;							ObjectReference TempMarker = GetClosestMarkerFromRandomSubPackage(BehaviourList[ArrayLength], TempNPCName)
							ObjectReference TempMarker = GetRandomMarkerFromSubPackage(BehaviourList[ArrayLength], TempNPCName)
							if TempMarker
								Actor SpawnedActor = SpawnNPCStatic(TempMarker, TempActorBase)
								if SpawnedActor
									NBF_Log("OnUpdate - Spawning - " + SpawnedActor.GetDisplayName())
									PrepareSpawnedNPC(SpawnedActor, ArrayLength)
									StorageUtil.SetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + SpawnedActor.GetDisplayName(), CurrentTime)
;									ArrayLength = 0
									ArrayLength2 = 0
								else
									NBF_Log("OnUpdate - Spawning - ERROR: Actor was not spawned")
								endif
							else
								ArrayLength2 = 0
								NBF_Log("OnUpdate - No Marker")
							endif
						endif
					endwhile
				endif
			else
				NBF_Log("OnUpdate - Checking " + BehaviourList[ArrayLength] + " - Timer")
			endif
		endwhile
	endif
	ProcessBusy = False
	if ProcessPending
		ProcessPending = False
		RegisterForSingleUpdate(0.5)
	endif
EndEvent

Bool Function CheckFaction(Actor TargetActor, Int LocationType)
	if LocationType == 0 ; Bandit
		if TargetActor.IsInFaction(FactionList[0])
			debug.Trace("_NBF_MainScr - CheckFaction - " + TargetActor.GetDisplayName() + " Bandit")
			return True
		endif
	elseif LocationType == 1
		if TargetActor.IsInFaction(FactionList[1])
			debug.Trace("_NBF_MainScr - CheckFaction - " + TargetActor.GetDisplayName() + " Forsworn")
			return True
		endif
	elseif LocationType == 2
		if TargetActor.IsInFaction(FactionList[2])
			debug.Trace("_NBF_MainScr - CheckFaction - " + TargetActor.GetDisplayName() + " Vampire")
			return True
		endif
	elseif LocationType == 3
		if TargetActor.IsInFaction(FactionList[3])
			debug.Trace("_NBF_MainScr - CheckFaction - " + TargetActor.GetDisplayName() + " Necromancer")
			return True
		endif
	elseif LocationType == 4
		if TargetActor.IsInFaction(FactionList[4])
			debug.Trace("_NBF_MainScr - CheckFaction - " + TargetActor.GetDisplayName() + " Warlock")
			return True
		endif
	elseif LocationType == 5
		if TargetActor.IsInFaction(FactionList[5]) && !TargetActor.IsGuard()
			debug.Trace("_NBF_MainScr - CheckFaction - " + TargetActor.GetDisplayName() + " Imperial Solder")
			return True
		endif
	elseif LocationType == 6
		if TargetActor.IsInFaction(FactionList[6]) && !TargetActor.IsGuard()
			debug.Trace("_NBF_MainScr - CheckFaction - " + TargetActor.GetDisplayName() + " Stormcloack Solder")
			return True
		endif
	elseif LocationType == 7
		if TargetActor.IsInFaction(FactionList[7])
			debug.Trace("_NBF_MainScr - CheckFaction - " + TargetActor.GetDisplayName() + " Guard(Whiterun)")
			return True
		endif
	elseif LocationType == 8
		if TargetActor.IsInFaction(FactionList[8])
			debug.Trace("_NBF_MainScr - CheckFaction - " + TargetActor.GetDisplayName() + " Guard(Dawnstar)")
			return True
		endif
	elseif LocationType == 9
		if TargetActor.IsInFaction(FactionList[9])
			debug.Trace("_NBF_MainScr - CheckFaction - " + TargetActor.GetDisplayName() + " Guard(Falkreath)")
			return True
		endif
	elseif LocationType == 10
		if TargetActor.IsInFaction(FactionList[10])
			debug.Trace("_NBF_MainScr - CheckFaction - " + TargetActor.GetDisplayName() + " Guard(Markarth)")
			return True
		endif
	elseif LocationType == 11
		if TargetActor.IsInFaction(FactionList[11])
			debug.Trace("_NBF_MainScr - CheckFaction - " + TargetActor.GetDisplayName() + " Guard(Morthal)")
			return True
		endif
	elseif LocationType == 12
		if TargetActor.IsInFaction(FactionList[12])
			debug.Trace("_NBF_MainScr - CheckFaction - " + TargetActor.GetDisplayName() + " Guard(Riften)")
			return True
		endif
	elseif LocationType == 13
		if TargetActor.IsInFaction(FactionList[13])
			debug.Trace("_NBF_MainScr - CheckFaction - " + TargetActor.GetDisplayName() + " Guard(Solitude)")
			return True
		endif
	elseif LocationType == 14
		if TargetActor.IsInFaction(FactionList[14])
			debug.Trace("_NBF_MainScr - CheckFaction - " + TargetActor.GetDisplayName() + " Guard(Windhelm)")
			return True
		endif
	elseif LocationType == 15
		if TargetActor.IsInFaction(FactionList[15])
			debug.Trace("_NBF_MainScr - CheckFaction - " + TargetActor.GetDisplayName() + " Guard(Winterhold)")
			return True
		endif
	elseif LocationType == 16
		if TargetActor.IsInFaction(FactionList[16])
			debug.Trace("_NBF_MainScr - CheckFaction - " + TargetActor.GetDisplayName() + " Guard(CidhnaMine)")
			return True
		endif
	endif
	debug.Trace("_NBF_MainScr - CheckFaction - " + TargetActor.GetDisplayName() + " False")
	return False
EndFunction

ObjectReference Function GetRandomMarkerFromSubPackage(String Behavior, String TempNPCName, Float MaxDistance = 10000.0)
	ObjectReference SavedMarker
	Int SavedIndex = -1
	Int SavedSubIndex = -1
	Int BehaviourIndex = BehaviourList.Find(Behavior)
	if BehaviourIndex != -1
		String SubPackageName
		SubPackageName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
		Int SubIndex = StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[BehaviourIndex] + "_" + SubPackageName + "_SubPackageCount")
		NBF_Log("GetRandomMarkerFromSubPackage - SubIndex: " + SubIndex)
		NBF_Log("GetRandomMarkerFromSubPackage - SubPackageName: " + SubPackageName)
		NBF_Log("GetRandomMarkerFromSubPackage - TempNPCName: " + TempNPCName)
		NBF_Log("GetRandomMarkerFromSubPackage - Behavior: " + Behavior)
		NBF_Log("GetRandomMarkerFromSubPackage - BehaviourIndex: " + BehaviourIndex)
		While SubIndex > 0 && SavedIndex == -1 && SavedSubIndex == -1
			Int ArrayLength = StorageUtil.FormListCount(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[BehaviourIndex] + "_" + SubPackageName + "_" + SubIndex)
			NBF_Log("GetRandomMarkerFromSubPackage - ArrayLength: " + ArrayLength)
			While ArrayLength > 0 && SavedIndex == -1 && SavedSubIndex == -1
				ArrayLength -= 1
				ObjectReference TempMarker = StorageUtil.FormListGet(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[BehaviourIndex] + "_" + SubPackageName + "_" + SubIndex, ArrayLength) as ObjectReference
				if TempMarker.GetWorldSpace() != PlayerRef.GetWorldSpace()
					StorageUtil.IntListAdd(NBFRegForm, "NBF_BlockSubPackageProcessingByIndex_" + Behavior, ArrayLength, false)
					NBF_Log("GetRandomMarkerFromSubPackage - Different WorldSpace")
					ArrayLength = -1
				endif
				Float Distance = TempMarker.GetDistance(PlayerRef)
				NBF_Log("GetRandomMarkerFromSubPackage - Distance: " + Distance)
				if Distance >= 100000
					StorageUtil.IntListAdd(NBFRegForm, "NBF_BlockSubPackageProcessingByIndex_" + Behavior, ArrayLength, false)
					ArrayLength = -1
					NBF_Log("GetRandomMarkerFromSubPackage - Too Far")
				endif
				if (Distance < MaxDistance)
					SavedIndex = ArrayLength
					SavedSubIndex = SubIndex
				endif
			endwhile
			SubIndex -= 1
		endwhile
		if SavedIndex != -1
			NBF_Log("GetRandomMarkerFromSubPackage - Found Marker")
			Int NumberOfAttempts = 20
			While SavedMarker == None && NumberOfAttempts > 0
				NumberOfAttempts -= 1
				Int RandomSubIndex = Utility.RandomInt(1, StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[BehaviourIndex] + "_" + SubPackageName + "_SubPackageCount"))
				Int RandomIndex = Utility.RandomInt(0, StorageUtil.FormListCount(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[BehaviourIndex] + "_" + SubPackageName + "_" + RandomSubIndex) - 1)
				SavedMarker = StorageUtil.FormListGet(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[BehaviourIndex] + "_" + SubPackageName + "_" + RandomSubIndex, RandomIndex) as ObjectReference
				NBF_Log("GetRandomMarkerFromSubPackage - SavedMarker: " + SavedMarker + " RandomSubIndex: " + RandomSubIndex + " RandomIndex: " + RandomIndex)
				if SavedMarker
					if PlayerRef.HasLos(SavedMarker)
						NBF_Log("GetRandomMarkerFromSubPackage - HasLos")
					endif
					if SavedMarker.GetDistance(PlayerRef) < 3000
						NBF_Log("GetRandomMarkerFromSubPackage - Distance")
					endif
					if !PlayerRef.HasLos(SavedMarker) && SavedMarker.GetDistance(PlayerRef) >= 3000
						NBF_Log("GetRandomMarkerFromSubPackage - Returning Marker")
						return SavedMarker
					else
						SavedMarker = None
					endif
				else
					SavedMarker = None
				endif
			endwhile
		else
			NBF_Log("GetRandomMarkerFromSubPackage - No Marker")
		endif
		return none
	else
		NBF_Log("GetRandomMarkerFromSubPackage - ERROR - Wrong Behavior")
	endif
EndFunction

ObjectReference Function GetClosestMarkerFromRandomSubPackage(String Behavior, String TempNPCName, Float MaxDistance = 10000.0)
	ObjectReference SavedMarker
	Int SavedIndex = -1
	Int SavedSubIndex = -1
	Float SavedDistance = 10000000.0
	Int BehaviourIndex = BehaviourList.Find(Behavior)
	if BehaviourIndex != -1
		String SubPackageName
		SubPackageName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
		Int SubIndex = StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[BehaviourIndex] + "_" + SubPackageName + "_SubPackageCount")
		NBF_Log("GetClosestMarkerFromRandomSubPackage - SubIndex: " + SubIndex)
		NBF_Log("GetClosestMarkerFromRandomSubPackage - SubPackageName: " + SubPackageName)
		NBF_Log("GetClosestMarkerFromRandomSubPackage - TempNPCName: " + TempNPCName)
		NBF_Log("GetClosestMarkerFromRandomSubPackage - Behavior: " + Behavior)
		NBF_Log("GetClosestMarkerFromRandomSubPackage - BehaviourIndex: " + BehaviourIndex)
		While SubIndex > 0
			Int ArrayLength = StorageUtil.FormListCount(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[BehaviourIndex] + "_" + SubPackageName + "_" + SubIndex)
			NBF_Log("GetClosestMarkerFromRandomSubPackage - ArrayLength: " + ArrayLength)
			While ArrayLength > 0
				ArrayLength -= 1
				ObjectReference TempMarker = StorageUtil.FormListGet(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[BehaviourIndex] + "_" + SubPackageName + "_" + SubIndex, ArrayLength) as ObjectReference
				if TempMarker.GetWorldSpace() != PlayerRef.GetWorldSpace()
					NBF_Log("GetClosestMarkerFromRandomSubPackage - Different WorldSpace")
					ArrayLength = -1
				endif
				Float Distance = TempMarker.GetDistance(PlayerRef)
				NBF_Log("GetClosestMarkerFromRandomSubPackage - Distance: " + Distance)
				if Distance >= 100000
					ArrayLength = -1
					NBF_Log("GetClosestMarkerFromRandomSubPackage - Too Far")
				endif
				if (Distance < SavedDistance) && (Distance < MaxDistance) && !PlayerRef.HasLos(TempMarker)
					SavedDistance = Distance
					SavedIndex = ArrayLength
					SavedSubIndex = SubIndex
				endif
			endwhile
			SubIndex -= 1
		endwhile
		if SavedIndex != -1
			NBF_Log("GetClosestMarkerFromRandomSubPackage - Found Marker")
;			SavedMarker = StorageUtil.FormListGet(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[BehaviourIndex] + "_" + SubPackageName + "_" + SavedSubIndex, SavedIndex) as ObjectReference
			Int NumberOfAttempts = 20
			While SavedMarker == None && NumberOfAttempts > 0
				NumberOfAttempts -= 1
				Int RandomSubIndex = Utility.RandomInt(1, StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[BehaviourIndex] + "_" + SubPackageName + "_SubPackageCount"))
				Int RandomIndex = Utility.RandomInt(0, StorageUtil.FormListCount(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[BehaviourIndex] + "_" + SubPackageName + "_" + RandomSubIndex) - 1)
				SavedMarker = StorageUtil.FormListGet(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[BehaviourIndex] + "_" + SubPackageName + "_" + RandomSubIndex, RandomIndex) as ObjectReference
				NBF_Log("GetClosestMarkerFromRandomSubPackage - SavedMarker: " + SavedMarker + " RandomSubIndex: " + RandomSubIndex + " RandomIndex: " + RandomIndex)
				if SavedMarker
					if PlayerRef.HasLos(SavedMarker)
						NBF_Log("GetClosestMarkerFromRandomSubPackage - HasLos")
					endif
					if SavedMarker.GetDistance(PlayerRef) < 3000
						NBF_Log("GetClosestMarkerFromRandomSubPackage - Distance")
					endif
					if !PlayerRef.HasLos(SavedMarker) && SavedMarker.GetDistance(PlayerRef) >= 3000
						NBF_Log("GetClosestMarkerFromRandomSubPackage - Returning Marker")
						return SavedMarker
					else
						SavedMarker = None
					endif
				else
					SavedMarker = None
				endif
			endwhile
				NBF_Log("GetClosestMarkerFromRandomSubPackage - Out Of Tries")
				return None
		else
			NBF_Log("GetClosestMarkerFromRandomSubPackage - No Marker")
		endif
;		return SavedMarker
	else
		NBF_Log("GetClosestMarkerFromRandomSubPackage - ERROR - Wrong Behavior")
	endif
EndFunction

ActorBase Function FindSuitableNPC(String Behavior, String ForcedNPCName = "")
	if Behavior == "Bandit"
		Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
		While ArrayLength > 0
			ArrayLength -= 1
			String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
			if ForcedNPCName != ""
				ArrayLength = -1
				TempNPCName = ForcedNPCName
			endif
			if StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName) == "Bandit"
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 1
					NBF_Log("FindSuitableNPC - Bandit " + TempNPCName + " Busy")
					NBF_Log("FindSuitableNPC - Bandit " + TempNPCName + " Spawn Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Bandit " + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded() && (StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) == 1)
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerBusy
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Bandit " + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Bandit " + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Bandit " + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				elseif StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 2
					NBF_Log("FindSuitableNPC - Bandit " + TempNPCName + " Dead")
					NBF_Log("FindSuitableNPC - Bandit " + TempNPCName + " Dead Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Bandit " + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded()
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerDead
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Bandit " + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Bandit " + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Bandit " + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				endif
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 0
					NBF_Log("FindSuitableNPC - Bandit " + TempNPCName + " Ready")
					if Utility.RandomInt(0, 100) <= StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName)
						String TempNPCMod = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName)
						Int TempNPCID = StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCIDByNPCName_" + TempNPCName)
						String TempSubPackageName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
						if TempSubPackageName
							ActorBase TempActorBase = Game.GetFormFromFile(TempNPCID, TempNPCMod) as ActorBase
							if TempActorBase
								NBF_Log("FindSuitableNPC - Bandit " + TempNPCName + " " + TempActorBase)
								return TempActorBase
							else
								NBF_Log("FindSuitableNPC - Bandit " + TempNPCName + " No Actor Base")
								return none
							endif
						else
							NBF_Log("FindSuitableNPC - Bandit " + TempNPCName + " Sub Package not selected")
						endif
					else
						NBF_Log("FindSuitableNPC - Bandit " + TempNPCName + " Low Chance")
					endif
				endif
			endif
		endwhile
	elseif Behavior == "Forsworn"
		Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
		While ArrayLength > 0
			ArrayLength -= 1
			String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
			if ForcedNPCName != ""
				ArrayLength = -1
				TempNPCName = ForcedNPCName
			endif
			if StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName) == "Forsworn"
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 1
					NBF_Log("FindSuitableNPC - Forsworn " + TempNPCName + " Busy")
					NBF_Log("FindSuitableNPC - Forsworn " + TempNPCName + " Spawn Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Forsworn " + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded() && (StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) == 1)
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerBusy
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Forsworn " + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Forsworn " + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Forsworn " + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				elseif StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 2
					NBF_Log("FindSuitableNPC - Forsworn " + TempNPCName + " Dead")
					NBF_Log("FindSuitableNPC - Forsworn " + TempNPCName + " Dead Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Forsworn " + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded()
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerDead
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Forsworn " + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Forsworn " + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Forsworn " + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				endif
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 0
					NBF_Log("FindSuitableNPC - Forsworn " + TempNPCName + " Ready")
					if Utility.RandomInt(0, 100) <= StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName)
						String TempNPCMod = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName)
						Int TempNPCID = StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCIDByNPCName_" + TempNPCName)
						String TempSubPackageName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
						if TempSubPackageName
							ActorBase TempActorBase = Game.GetFormFromFile(TempNPCID, TempNPCMod) as ActorBase
							if TempActorBase
								NBF_Log("FindSuitableNPC - Forsworn " + TempNPCName + " " + TempActorBase)
								return TempActorBase
							else
								NBF_Log("FindSuitableNPC - Forsworn " + TempNPCName + " No Actor Base")
								return none
							endif
						else
							NBF_Log("FindSuitableNPC - Forsworn" + TempNPCName + " Sub Package not selected")
						endif
					else
						NBF_Log("FindSuitableNPC - Forsworn " + TempNPCName + " Low Chance")
					endif
				endif
			endif
		endwhile
	elseif Behavior == "Vampire"
		Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
		While ArrayLength > 0
			ArrayLength -= 1
			String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
			if ForcedNPCName != ""
				ArrayLength = -1
				TempNPCName = ForcedNPCName
			endif
			if StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName) == "Vampire"
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 1
					NBF_Log("FindSuitableNPC - Vampire " + TempNPCName + " Busy")
					NBF_Log("FindSuitableNPC - Vampire " + TempNPCName + " Spawn Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Vampire " + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded() && (StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) == 1)
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerBusy
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Vampire " + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Vampire " + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Vampire " + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				elseif StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 2
					NBF_Log("FindSuitableNPC - Vampire " + TempNPCName + " Dead")
					NBF_Log("FindSuitableNPC - Vampire " + TempNPCName + " Dead Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Vampire " + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded()
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerDead
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Vampire " + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Vampire " + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Vampire " + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				endif
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 0
					NBF_Log("FindSuitableNPC - Vampire " + TempNPCName + " Ready")
					if Utility.RandomInt(0, 100) <= StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName)
						String TempNPCMod = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName)
						Int TempNPCID = StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCIDByNPCName_" + TempNPCName)
						String TempSubPackageName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
						if TempSubPackageName
							ActorBase TempActorBase = Game.GetFormFromFile(TempNPCID, TempNPCMod) as ActorBase
							if TempActorBase
								NBF_Log("FindSuitableNPC - Vampire " + TempNPCName + " " + TempActorBase)
								return TempActorBase
							else
								NBF_Log("FindSuitableNPC - Vampire " + TempNPCName + " No Actor Base")
								return none
							endif
						else
							NBF_Log("FindSuitableNPC - Vampire " + TempNPCName + " Sub Package not selected")
						endif
					else
						NBF_Log("FindSuitableNPC - Vampire " + TempNPCName + " Low Chance")
					endif
				endif
			endif
		endwhile
	elseif Behavior == "Necromancer"
		Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
		While ArrayLength > 0
			ArrayLength -= 1
			String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
			if ForcedNPCName != ""
				ArrayLength = -1
				TempNPCName = ForcedNPCName
			endif
			if StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName) == "Necromancer"
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 1
					NBF_Log("FindSuitableNPC - Necromancer " + TempNPCName + " Busy")
					NBF_Log("FindSuitableNPC - Necromancer " + TempNPCName + " Spawn Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Necromancer " + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded() && (StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) == 1)
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerBusy
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Necromancer " + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Necromancer " + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Necromancer " + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				elseif StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 2
					NBF_Log("FindSuitableNPC - Necromancer " + TempNPCName + " Dead")
					NBF_Log("FindSuitableNPC - Necromancer " + TempNPCName + " Dead Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Necromancer " + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded()
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerDead
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Necromancer " + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Necromancer " + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Necromancer " + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				endif
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 0
					NBF_Log("FindSuitableNPC - Necromancer " + TempNPCName + " Ready")
					if Utility.RandomInt(0, 100) <= StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName)
						String TempNPCMod = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName)
						Int TempNPCID = StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCIDByNPCName_" + TempNPCName)
						String TempSubPackageName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
						if TempSubPackageName
							ActorBase TempActorBase = Game.GetFormFromFile(TempNPCID, TempNPCMod) as ActorBase
							if TempActorBase
								NBF_Log("FindSuitableNPC - Necromancer " + TempNPCName + " " + TempActorBase)
								return TempActorBase
							else
								NBF_Log("FindSuitableNPC - Necromancer " + TempNPCName + " No Actor Base")
								return none
							endif
						else
							NBF_Log("FindSuitableNPC - Necromancer " + TempNPCName + " Sub Package not selected")
						endif
					else
						NBF_Log("FindSuitableNPC - Necromancer " + TempNPCName + " Low Chance")
					endif
				endif
			endif
		endwhile
	elseif Behavior == "Warlock"
		Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
		While ArrayLength > 0
			ArrayLength -= 1
			String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
			if ForcedNPCName != ""
				ArrayLength = -1
				TempNPCName = ForcedNPCName
			endif
			if StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName) == "Warlock"
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 1
					NBF_Log("FindSuitableNPC - Warlock " + TempNPCName + " Busy")
					NBF_Log("FindSuitableNPC - Warlock " + TempNPCName + " Spawn Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Warlock " + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded() && (StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) == 1)
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerBusy
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Warlock " + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Warlock " + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Warlock " + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				elseif StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 2
					NBF_Log("FindSuitableNPC - Warlock " + TempNPCName + " Dead")
					NBF_Log("FindSuitableNPC - Warlock " + TempNPCName + " Dead Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Warlock " + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded()
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerDead
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Warlock " + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Warlock " + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Warlock " + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				endif
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 0
					NBF_Log("FindSuitableNPC - Warlock " + TempNPCName + " Ready")
					if Utility.RandomInt(0, 100) <= StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName)
						String TempNPCMod = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName)
						Int TempNPCID = StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCIDByNPCName_" + TempNPCName)
						String TempSubPackageName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
						if TempSubPackageName
							ActorBase TempActorBase = Game.GetFormFromFile(TempNPCID, TempNPCMod) as ActorBase
							if TempActorBase
								NBF_Log("FindSuitableNPC - Warlock " + TempNPCName + " " + TempActorBase)
								return TempActorBase
							else
								NBF_Log("FindSuitableNPC - Warlock " + TempNPCName + " No Actor Base")
								return none
							endif
						else
							NBF_Log("FindSuitableNPC - Warlock " + TempNPCName + " Sub Package not selected")
						endif
					else
						NBF_Log("FindSuitableNPC - Warlock " + TempNPCName + " Low Chance")
					endif
				endif
			endif
		endwhile
	elseif Behavior == "Imperial Solder"
;		Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
;		While ArrayLength > 0
;			ArrayLength -= 1
;			String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
;			if ForcedNPCName != ""
;				ArrayLength = -1
;				TempNPCName = ForcedNPCName
;			endif
;			if StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName) == "Imperial Solder"
;				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 1
;					NBF_Log("FindSuitableNPC - Imperial Solder " + TempNPCName + " Busy")
;					NBF_Log("FindSuitableNPC - Imperial Solder " + TempNPCName + " Spawn Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName))
;					NBF_Log("FindSuitableNPC - Imperial Solder " + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
;					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
;					if !TempActor.Is3DLoaded() && (StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) == 1)
;						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerBusy
;							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
;							if FindEmptyAlias(TempActor, false) >= 0
;								NBF_Log("FindSuitableNPC - Imperial Solder " + TempNPCName + " Removed from Alias")
;							else
;								NBF_Log("FindSuitableNPC - Imperial Solder " + TempNPCName + " Not in Alias")
;							endif
;							TempActor.Disable()
;							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
;							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
;							NBF_Log("FindSuitableNPC - Imperial Solder " + TempNPCName + " Set NPC Status to Ready")
;						endif
;					endif
;				elseif StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 2
;					NBF_Log("FindSuitableNPC - Imperial Solder " + TempNPCName + " Dead")
;					NBF_Log("FindSuitableNPC - Imperial Solder " + TempNPCName + " Dead Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName))
;					NBF_Log("FindSuitableNPC - Imperial Solder " + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
;					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
;					if !TempActor.Is3DLoaded()
;						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerDead
;							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
;							if FindEmptyAlias(TempActor, false) >= 0
;								NBF_Log("FindSuitableNPC - Imperial Solder " + TempNPCName + " Removed from Alias")
;							else
;								NBF_Log("FindSuitableNPC - Imperial Solder " + TempNPCName + " Not in Alias")
;							endif
;							TempActor.Disable()
;							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
;							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
;							NBF_Log("FindSuitableNPC - Imperial Solder " + TempNPCName + " Set NPC Status to Ready")
;						endif
;					endif
;				endif
;				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 0
;					NBF_Log("FindSuitableNPC - Imperial Solder " + TempNPCName + " Ready")
;					if Utility.RandomInt(0, 100) <= StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName)
;						String TempNPCMod = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName)
;						Int TempNPCID = StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCIDByNPCName_" + TempNPCName)
;						String TempSubPackageName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
;						if TempSubPackageName
;							ActorBase TempActorBase = Game.GetFormFromFile(TempNPCID, TempNPCMod) as ActorBase
;							if TempActorBase
;								NBF_Log("FindSuitableNPC - Imperial Solder " + TempNPCName + " " + TempActorBase)
;								return TempActorBase
;							else
;								NBF_Log("FindSuitableNPC - Imperial Solder " + TempNPCName + " No Actor Base")
;								return none
;							endif
;						else
;							NBF_Log("FindSuitableNPC - Imperial Solder " + TempNPCName + " Sub Package not selected")
;						endif
;					else
;						NBF_Log("FindSuitableNPC - Imperial Solder " + TempNPCName + " Low Chance")
;					endif
;				endif
;			endif
;		endwhile
	elseif Behavior == "Stormcloack Solder"
;		Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
;		While ArrayLength > 0
;			ArrayLength -= 1
;			String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
;			if ForcedNPCName != ""
;				ArrayLength = -1
;				TempNPCName = ForcedNPCName
;			endif
;			if StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName) == "Stormcloack Solder"
;				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 1
;					NBF_Log("FindSuitableNPC - Stormcloack Solder " + TempNPCName + " Busy")
;					NBF_Log("FindSuitableNPC - Stormcloack Solder " + TempNPCName + " Spawn Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName))
;					NBF_Log("FindSuitableNPC - Stormcloack Solder " + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
;					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
;					if !TempActor.Is3DLoaded() && (StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) == 1)
;						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerBusy
;							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
;							if FindEmptyAlias(TempActor, false) >= 0
;								NBF_Log("FindSuitableNPC - Stormcloack Solder " + TempNPCName + " Removed from Alias")
;							else
;								NBF_Log("FindSuitableNPC - Stormcloack Solder " + TempNPCName + " Not in Alias")
;							endif
;							TempActor.Disable()
;							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
;							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
;							NBF_Log("FindSuitableNPC - Stormcloack Solder " + TempNPCName + " Set NPC Status to Ready")
;						endif
;					endif
;				elseif StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 2
;					NBF_Log("FindSuitableNPC - Stormcloack Solder " + TempNPCName + " Dead")
;					NBF_Log("FindSuitableNPC - Stormcloack Solder " + TempNPCName + " Dead Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName))
;					NBF_Log("FindSuitableNPC - Stormcloack Solder " + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
;					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
;					if !TempActor.Is3DLoaded()
;						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerDead
;							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
;							if FindEmptyAlias(TempActor, false) >= 0
;								NBF_Log("FindSuitableNPC - Stormcloack Solder " + TempNPCName + " Removed from Alias")
;							else
;								NBF_Log("FindSuitableNPC - Stormcloack Solder " + TempNPCName + " Not in Alias")
;							endif
;							TempActor.Disable()
;							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
;							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
;							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
;							NBF_Log("FindSuitableNPC - Stormcloack Solder " + TempNPCName + " Set NPC Status to Ready")
;						endif
;					endif
;				endif
;				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 0
;					NBF_Log("FindSuitableNPC - Stormcloack Solder " + TempNPCName + " Ready")
;					if Utility.RandomInt(0, 100) <= StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName)
;						String TempNPCMod = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName)
;						Int TempNPCID = StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCIDByNPCName_" + TempNPCName)
;						String TempSubPackageName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
;						if TempSubPackageName
;							ActorBase TempActorBase = Game.GetFormFromFile(TempNPCID, TempNPCMod) as ActorBase
;							if TempActorBase
;								NBF_Log("FindSuitableNPC - Stormcloack Solder " + TempNPCName + " " + TempActorBase)
;								return TempActorBase
;							else
;								NBF_Log("FindSuitableNPC - Stormcloack Solder " + TempNPCName + " No Actor Base")
;								return none
;							endif
;						else
;							NBF_Log("FindSuitableNPC - Stormcloack Solder " + TempNPCName + " Sub Package not selected")
;						endif
;					else
;						NBF_Log("FindSuitableNPC - Stormcloack Solder " + TempNPCName + " Low Chance")
;					endif
;				endif
;			endif
;		endwhile
	elseif Behavior == "Guard(Whiterun)"
		Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
		While ArrayLength > 0
			ArrayLength -= 1
			String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
			if ForcedNPCName != ""
				ArrayLength = -1
				TempNPCName = ForcedNPCName
			endif
			if StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName) == "Guard(Whiterun)"
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 1
					NBF_Log("FindSuitableNPC - Guard(Whiterun) " + TempNPCName + " Busy")
					NBF_Log("FindSuitableNPC - Guard(Whiterun) " + TempNPCName + " Spawn Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(Whiterun) " + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded() && (StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) == 1)
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerBusy
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(Whiterun) " + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(Whiterun) " + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(Whiterun) " + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				elseif StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 2
					NBF_Log("FindSuitableNPC - Guard(Whiterun) " + TempNPCName + " Dead")
					NBF_Log("FindSuitableNPC - Guard(Whiterun) " + TempNPCName + " Dead Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(Whiterun) " + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded()
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerDead
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(Whiterun) " + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(Whiterun) " + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(Whiterun) " + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				endif
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 0
					NBF_Log("FindSuitableNPC - Guard(Whiterun) " + TempNPCName + " Ready")
					if Utility.RandomInt(0, 100) <= StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName)
						String TempNPCMod = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName)
						Int TempNPCID = StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCIDByNPCName_" + TempNPCName)
						String TempSubPackageName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
						if TempSubPackageName
							ActorBase TempActorBase = Game.GetFormFromFile(TempNPCID, TempNPCMod) as ActorBase
							if TempActorBase
								NBF_Log("FindSuitableNPC - Guard(Whiterun) " + TempNPCName + " " + TempActorBase)
								return TempActorBase
							else
								NBF_Log("FindSuitableNPC - Guard(Whiterun) " + TempNPCName + " No Actor Base")
								return none
							endif
						else
							NBF_Log("FindSuitableNPC - Guard(Whiterun) " + TempNPCName + " Sub Package not selected")
						endif
					else
						NBF_Log("FindSuitableNPC - Guard(Whiterun) " + TempNPCName + " Low Chance")
					endif
				endif
			endif
		endwhile
	elseif Behavior == "Guard(Dawnstar)"
		Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
		While ArrayLength > 0
			ArrayLength -= 1
			String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
			if ForcedNPCName != ""
				ArrayLength = -1
				TempNPCName = ForcedNPCName
			endif
			if StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName) == "Guard(Dawnstar)"
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 1
					NBF_Log("FindSuitableNPC - Guard(Dawnstar)" + TempNPCName + " Busy")
					NBF_Log("FindSuitableNPC - Guard(Dawnstar)" + TempNPCName + " Spawn Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(Dawnstar)" + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded() && (StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) == 1)
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerBusy
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(Dawnstar)" + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(Dawnstar)" + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(Dawnstar)" + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				elseif StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 2
					NBF_Log("FindSuitableNPC - Guard(Dawnstar)" + TempNPCName + " Dead")
					NBF_Log("FindSuitableNPC - Guard(Dawnstar)" + TempNPCName + " Dead Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(Dawnstar)" + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded()
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerDead
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(Dawnstar)" + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(Dawnstar)" + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(Dawnstar)" + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				endif
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 0
					NBF_Log("FindSuitableNPC - Guard(Dawnstar)" + TempNPCName + " Ready")
					if Utility.RandomInt(0, 100) <= StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName)
						String TempNPCMod = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName)
						Int TempNPCID = StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCIDByNPCName_" + TempNPCName)
						String TempSubPackageName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
						if TempSubPackageName
							ActorBase TempActorBase = Game.GetFormFromFile(TempNPCID, TempNPCMod) as ActorBase
							if TempActorBase
								NBF_Log("FindSuitableNPC - Guard(Dawnstar)" + TempNPCName + " " + TempActorBase)
								return TempActorBase
							else
								NBF_Log("FindSuitableNPC - Guard(Dawnstar)" + TempNPCName + " No Actor Base")
								return none
							endif
						else
							NBF_Log("FindSuitableNPC - Bandit" + TempNPCName + " Sub Package not selected")
						endif
					else
						NBF_Log("FindSuitableNPC - Guard(Dawnstar)" + TempNPCName + " Low Chance")
					endif
				endif
			endif
		endwhile
	elseif Behavior == "Guard(Falkreath)"
		Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
		While ArrayLength > 0
			ArrayLength -= 1
			String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
			if ForcedNPCName != ""
				ArrayLength = -1
				TempNPCName = ForcedNPCName
			endif
			if StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName) == "Guard(Falkreath)"
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 1
					NBF_Log("FindSuitableNPC - Guard(Falkreath)" + TempNPCName + " Busy")
					NBF_Log("FindSuitableNPC - Guard(Falkreath)" + TempNPCName + " Spawn Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(Falkreath)" + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded() && (StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) == 1)
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerBusy
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(Falkreath)" + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(Falkreath)" + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(Falkreath)" + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				elseif StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 2
					NBF_Log("FindSuitableNPC - Guard(Falkreath)" + TempNPCName + " Dead")
					NBF_Log("FindSuitableNPC - Guard(Falkreath)" + TempNPCName + " Dead Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(Falkreath)" + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded()
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerDead
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(Falkreath)" + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(Falkreath)" + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(Falkreath)" + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				endif
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 0
					NBF_Log("FindSuitableNPC - Guard(Falkreath)" + TempNPCName + " Ready")
					if Utility.RandomInt(0, 100) <= StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName)
						String TempNPCMod = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName)
						Int TempNPCID = StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCIDByNPCName_" + TempNPCName)
						String TempSubPackageName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
						if TempSubPackageName
							ActorBase TempActorBase = Game.GetFormFromFile(TempNPCID, TempNPCMod) as ActorBase
							if TempActorBase
								NBF_Log("FindSuitableNPC - Guard(Falkreath)" + TempNPCName + " " + TempActorBase)
								return TempActorBase
							else
								NBF_Log("FindSuitableNPC - Guard(Falkreath)" + TempNPCName + " No Actor Base")
								return none
							endif
						else
							NBF_Log("FindSuitableNPC - Bandit" + TempNPCName + " Sub Package not selected")
						endif
					else
						NBF_Log("FindSuitableNPC - Guard(Falkreath)" + TempNPCName + " Low Chance")
					endif
				endif
			endif
		endwhile
	elseif Behavior == "Guard(Markarth)"
		Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
		While ArrayLength > 0
			ArrayLength -= 1
			String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
			if ForcedNPCName != ""
				ArrayLength = -1
				TempNPCName = ForcedNPCName
			endif
			if StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName) == "Guard(Markarth)"
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 1
					NBF_Log("FindSuitableNPC - Guard(Markarth)" + TempNPCName + " Busy")
					NBF_Log("FindSuitableNPC - Guard(Markarth)" + TempNPCName + " Spawn Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(Markarth)" + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded() && (StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) == 1)
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerBusy
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(Markarth)" + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(Markarth)" + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(Markarth)" + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				elseif StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 2
					NBF_Log("FindSuitableNPC - Guard(Markarth)" + TempNPCName + " Dead")
					NBF_Log("FindSuitableNPC - Guard(Markarth)" + TempNPCName + " Dead Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(Markarth)" + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded()
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerDead
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(Markarth)" + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(Markarth)" + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(Markarth)" + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				endif
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 0
					NBF_Log("FindSuitableNPC - Guard(Markarth)" + TempNPCName + " Ready")
					if Utility.RandomInt(0, 100) <= StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName)
						String TempNPCMod = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName)
						Int TempNPCID = StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCIDByNPCName_" + TempNPCName)
						String TempSubPackageName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
						if TempSubPackageName
							ActorBase TempActorBase = Game.GetFormFromFile(TempNPCID, TempNPCMod) as ActorBase
							if TempActorBase
								NBF_Log("FindSuitableNPC - Guard(Markarth)" + TempNPCName + " " + TempActorBase)
								return TempActorBase
							else
								NBF_Log("FindSuitableNPC - Guard(Markarth)" + TempNPCName + " No Actor Base")
								return none
							endif
						else
							NBF_Log("FindSuitableNPC - Bandit" + TempNPCName + " Sub Package not selected")
						endif
					else
						NBF_Log("FindSuitableNPC - Guard(Markarth)" + TempNPCName + " Low Chance")
					endif
				endif
			endif
		endwhile
	elseif Behavior == "Guard(Morthal)"
		Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
		While ArrayLength > 0
			ArrayLength -= 1
			String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
			if ForcedNPCName != ""
				ArrayLength = -1
				TempNPCName = ForcedNPCName
			endif
			if StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName) == "Guard(Morthal)"
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 1
					NBF_Log("FindSuitableNPC - Guard(Morthal)" + TempNPCName + " Busy")
					NBF_Log("FindSuitableNPC - Guard(Morthal)" + TempNPCName + " Spawn Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(Morthal)" + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded() && (StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) == 1)
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerBusy
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(Morthal)" + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(Morthal)" + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(Morthal)" + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				elseif StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 2
					NBF_Log("FindSuitableNPC - Guard(Morthal)" + TempNPCName + " Dead")
					NBF_Log("FindSuitableNPC - Guard(Morthal)" + TempNPCName + " Dead Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(Morthal)" + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded()
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerDead
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(Morthal)" + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(Morthal)" + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(Morthal)" + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				endif
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 0
					NBF_Log("FindSuitableNPC - Guard(Morthal)" + TempNPCName + " Ready")
					if Utility.RandomInt(0, 100) <= StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName)
						String TempNPCMod = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName)
						Int TempNPCID = StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCIDByNPCName_" + TempNPCName)
						String TempSubPackageName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
						if TempSubPackageName
							ActorBase TempActorBase = Game.GetFormFromFile(TempNPCID, TempNPCMod) as ActorBase
							if TempActorBase
								NBF_Log("FindSuitableNPC - Guard(Morthal)" + TempNPCName + " " + TempActorBase)
								return TempActorBase
							else
								NBF_Log("FindSuitableNPC - Guard(Morthal)" + TempNPCName + " No Actor Base")
								return none
							endif
						else
							NBF_Log("FindSuitableNPC - Bandit" + TempNPCName + " Sub Package not selected")
						endif
					else
						NBF_Log("FindSuitableNPC - Guard(Morthal)" + TempNPCName + " Low Chance")
					endif
				endif
			endif
		endwhile
	elseif Behavior == "Guard(Riften)"
		Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
		While ArrayLength > 0
			ArrayLength -= 1
			String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
			if ForcedNPCName != ""
				ArrayLength = -1
				TempNPCName = ForcedNPCName
			endif
			if StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName) == "Guard(Riften)"
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 1
					NBF_Log("FindSuitableNPC - Guard(Riften)" + TempNPCName + " Busy")
					NBF_Log("FindSuitableNPC - Guard(Riften)" + TempNPCName + " Spawn Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(Riften)" + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded() && (StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) == 1)
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerBusy
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(Riften)" + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(Riften)" + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(Riften)" + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				elseif StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 2
					NBF_Log("FindSuitableNPC - Guard(Riften)" + TempNPCName + " Dead")
					NBF_Log("FindSuitableNPC - Guard(Riften)" + TempNPCName + " Dead Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(Riften)" + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded()
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerDead
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(Riften)" + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(Riften)" + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(Riften)" + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				endif
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 0
					NBF_Log("FindSuitableNPC - Guard(Riften)" + TempNPCName + " Ready")
					if Utility.RandomInt(0, 100) <= StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName)
						String TempNPCMod = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName)
						Int TempNPCID = StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCIDByNPCName_" + TempNPCName)
						String TempSubPackageName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
						if TempSubPackageName
							ActorBase TempActorBase = Game.GetFormFromFile(TempNPCID, TempNPCMod) as ActorBase
							if TempActorBase
								NBF_Log("FindSuitableNPC - Guard(Riften)" + TempNPCName + " " + TempActorBase)
								return TempActorBase
							else
								NBF_Log("FindSuitableNPC - Guard(Riften)" + TempNPCName + " No Actor Base")
								return none
							endif
						else
							NBF_Log("FindSuitableNPC - Bandit" + TempNPCName + " Sub Package not selected")
						endif
					else
						NBF_Log("FindSuitableNPC - Guard(Riften)" + TempNPCName + " Low Chance")
					endif
				endif
			endif
		endwhile
	elseif Behavior == "Guard(Solitude)"
		Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
		While ArrayLength > 0
			ArrayLength -= 1
			String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
			if ForcedNPCName != ""
				ArrayLength = -1
				TempNPCName = ForcedNPCName
			endif
			if StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName) == "Guard(Solitude)"
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 1
					NBF_Log("FindSuitableNPC - Guard(Solitude)" + TempNPCName + " Busy")
					NBF_Log("FindSuitableNPC - Guard(Solitude)" + TempNPCName + " Spawn Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(Solitude)" + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded() && (StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) == 1)
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerBusy
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(Solitude)" + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(Solitude)" + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(Solitude)" + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				elseif StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 2
					NBF_Log("FindSuitableNPC - Guard(Solitude)" + TempNPCName + " Dead")
					NBF_Log("FindSuitableNPC - Guard(Solitude)" + TempNPCName + " Dead Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(Solitude)" + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded()
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerDead
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(Solitude)" + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(Solitude)" + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(Solitude)" + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				endif
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 0
					NBF_Log("FindSuitableNPC - Guard(Solitude)" + TempNPCName + " Ready")
					if Utility.RandomInt(0, 100) <= StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName)
						String TempNPCMod = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName)
						Int TempNPCID = StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCIDByNPCName_" + TempNPCName)
						String TempSubPackageName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
						if TempSubPackageName
							ActorBase TempActorBase = Game.GetFormFromFile(TempNPCID, TempNPCMod) as ActorBase
							if TempActorBase
								NBF_Log("FindSuitableNPC - Guard(Solitude)" + TempNPCName + " " + TempActorBase)
								return TempActorBase
							else
								NBF_Log("FindSuitableNPC - Guard(Solitude)" + TempNPCName + " No Actor Base")
								return none
							endif
						else
							NBF_Log("FindSuitableNPC - Bandit" + TempNPCName + " Sub Package not selected")
						endif
					else
						NBF_Log("FindSuitableNPC - Guard(Solitude)" + TempNPCName + " Low Chance")
					endif
				endif
			endif
		endwhile
	elseif Behavior == "Guard(Windhelm)"
		Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
		While ArrayLength > 0
			ArrayLength -= 1
			String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
			if ForcedNPCName != ""
				ArrayLength = -1
				TempNPCName = ForcedNPCName
			endif
			if StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName) == "Guard(Windhelm)"
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 1
					NBF_Log("FindSuitableNPC - Guard(Windhelm)" + TempNPCName + " Busy")
					NBF_Log("FindSuitableNPC - Guard(Windhelm)" + TempNPCName + " Spawn Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(Windhelm)" + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded() && (StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) == 1)
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerBusy
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(Windhelm)" + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(Windhelm)" + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(Windhelm)" + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				elseif StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 2
					NBF_Log("FindSuitableNPC - Guard(Windhelm)" + TempNPCName + " Dead")
					NBF_Log("FindSuitableNPC - Guard(Windhelm)" + TempNPCName + " Dead Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(Windhelm)" + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded()
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerDead
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(Windhelm)" + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(Windhelm)" + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(Windhelm)" + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				endif
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 0
					NBF_Log("FindSuitableNPC - Guard(Windhelm)" + TempNPCName + " Ready")
					if Utility.RandomInt(0, 100) <= StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName)
						String TempNPCMod = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName)
						Int TempNPCID = StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCIDByNPCName_" + TempNPCName)
						String TempSubPackageName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
						if TempSubPackageName
							ActorBase TempActorBase = Game.GetFormFromFile(TempNPCID, TempNPCMod) as ActorBase
							if TempActorBase
								NBF_Log("FindSuitableNPC - Guard(Windhelm)" + TempNPCName + " " + TempActorBase)
								return TempActorBase
							else
								NBF_Log("FindSuitableNPC - Guard(Windhelm)" + TempNPCName + " No Actor Base")
								return none
							endif
						else
							NBF_Log("FindSuitableNPC - Bandit" + TempNPCName + " Sub Package not selected")
						endif
					else
						NBF_Log("FindSuitableNPC - Guard(Windhelm)" + TempNPCName + " Low Chance")
					endif
				endif
			endif
		endwhile
	elseif Behavior == "Guard(Winterhold)"
		Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
		While ArrayLength > 0
			ArrayLength -= 1
			String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
			if ForcedNPCName != ""
				ArrayLength = -1
				TempNPCName = ForcedNPCName
			endif
			if StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName) == "Guard(Winterhold)"
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 1
					NBF_Log("FindSuitableNPC - Guard(Winterhold)" + TempNPCName + " Busy")
					NBF_Log("FindSuitableNPC - Guard(Winterhold)" + TempNPCName + " Spawn Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(Winterhold)" + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded() && (StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) == 1)
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerBusy
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(Winterhold)" + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(Winterhold)" + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(Winterhold)" + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				elseif StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 2
					NBF_Log("FindSuitableNPC - Guard(Winterhold)" + TempNPCName + " Dead")
					NBF_Log("FindSuitableNPC - Guard(Winterhold)" + TempNPCName + " Dead Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(Winterhold)" + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded()
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerDead
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(Winterhold)" + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(Winterhold)" + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(Winterhold)" + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				endif
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 0
					NBF_Log("FindSuitableNPC - Guard(Winterhold)" + TempNPCName + " Ready")
					if Utility.RandomInt(0, 100) <= StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName)
						String TempNPCMod = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName)
						Int TempNPCID = StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCIDByNPCName_" + TempNPCName)
						String TempSubPackageName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
						if TempSubPackageName
							ActorBase TempActorBase = Game.GetFormFromFile(TempNPCID, TempNPCMod) as ActorBase
							if TempActorBase
								NBF_Log("FindSuitableNPC - Guard(Winterhold)" + TempNPCName + " " + TempActorBase)
								return TempActorBase
							else
								NBF_Log("FindSuitableNPC - Guard(Winterhold)" + TempNPCName + " No Actor Base")
								return none
							endif
						else
							NBF_Log("FindSuitableNPC - Bandit" + TempNPCName + " Sub Package not selected")
						endif
					else
						NBF_Log("FindSuitableNPC - Guard(Winterhold)" + TempNPCName + " Low Chance")
					endif
				endif
			endif
		endwhile
	elseif Behavior == "Guard(CidhnaMine)"
		Int ArrayLength = StorageUtil.StringListCount(NBFRegForm, "NBF_RegisteredNPC_Name")
		While ArrayLength > 0
			ArrayLength -= 1
			String TempNPCName = StorageUtil.StringListGet(NBFRegForm, "NBF_RegisteredNPC_Name", ArrayLength)
			if ForcedNPCName != ""
				ArrayLength = -1
				TempNPCName = ForcedNPCName
			endif
			if StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + TempNPCName) == "Guard(CidhnaMine)"
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 1
					NBF_Log("FindSuitableNPC - Guard(CidhnaMine)" + TempNPCName + " Busy")
					NBF_Log("FindSuitableNPC - Guard(CidhnaMine)" + TempNPCName + " Spawn Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(CidhnaMine)" + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded() && (StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_AllowDispawn_" + TempNPCName, 1) == 1)
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerBusy
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(CidhnaMine)" + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(CidhnaMine)" + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(CidhnaMine)" + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				elseif StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 2
					NBF_Log("FindSuitableNPC - Guard(CidhnaMine)" + TempNPCName + " Dead")
					NBF_Log("FindSuitableNPC - Guard(CidhnaMine)" + TempNPCName + " Dead Time: " + StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName))
					NBF_Log("FindSuitableNPC - Guard(CidhnaMine)" + TempNPCName + " Current Time: " + Utility.GetCurrentGameTime())
					Actor TempActor = StorageUtil.GetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName) as Actor
					if !TempActor.Is3DLoaded()
						if (Utility.GetCurrentGameTime() - StorageUtil.GetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)) * 24 >= MCM.RespawnTimerDead
							StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 0)
							if FindEmptyAlias(TempActor, false) >= 0
								NBF_Log("FindSuitableNPC - Guard(CidhnaMine)" + TempNPCName + " Removed from Alias")
							else
								NBF_Log("FindSuitableNPC - Guard(CidhnaMine)" + TempNPCName + " Not in Alias")
							endif
							TempActor.Disable()
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
							StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
							StorageUtil.UnsetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName)
							NBF_Log("FindSuitableNPC - Guard(CidhnaMine)" + TempNPCName + " Set NPC Status to Ready")
						endif
					endif
				endif
				if StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName) == 0
					NBF_Log("FindSuitableNPC - Guard(CidhnaMine)" + TempNPCName + " Ready")
					if Utility.RandomInt(0, 100) <= StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_SpawnChance_" + TempNPCName)
						String TempNPCMod = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_ModNameByNPCName_" + TempNPCName)
						Int TempNPCID = StorageUtil.GetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCIDByNPCName_" + TempNPCName)
						String TempSubPackageName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + TempNPCName)
						if TempSubPackageName
							ActorBase TempActorBase = Game.GetFormFromFile(TempNPCID, TempNPCMod) as ActorBase
							if TempActorBase
								NBF_Log("FindSuitableNPC - Guard(CidhnaMine)" + TempNPCName + " " + TempActorBase)
								return TempActorBase
							else
								NBF_Log("FindSuitableNPC - Guard(CidhnaMine)" + TempNPCName + " No Actor Base")
								return none
							endif
						else
							NBF_Log("FindSuitableNPC - Bandit" + TempNPCName + " Sub Package not selected")
						endif
					else
						NBF_Log("FindSuitableNPC - Guard(CidhnaMine)" + TempNPCName + " Low Chance")
					endif
				endif
			endif
		endwhile
	endif
EndFunction

Actor Function SpawnNPC(Actor TargetActor, ActorBase TargetActorBase)
	Actor TempActor = TargetActor.PlaceAtMe(TargetActorBase, 1) as Actor
	TempActor.Disable()
	TempActor.Enable()
	return TempActor			; USE THIS
EndFunction

Actor Function SpawnNPCStatic(ObjectReference TargetObject, ActorBase TargetActorBase)
	Actor TempActor = TargetObject.PlaceAtMe(TargetActorBase, 1) as Actor
	TempActor.Disable()
	TempActor.Enable()
	return TempActor			; USE THIS
EndFunction

Function PrepareSpawnedNPC(Actor TargetActor, Int LocationType)
	NBF_Log("FindEmptyAlias - PrepareSpawnedNPC")
	String TempNPCName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_NPCNameByBaseID_" + TargetActor.GetActorBase().GetFormID())
;	String TempNPCName = TargetActor.GetDisplayName()
	NBF_Log("FindEmptyAlias - PrepareSpawnedNPC - TempNPCName: " + TempNPCName)
	Int Index = FindEmptyAlias(TargetActor, true)
	if Index >= 0
		NBF_Log("FindEmptyAlias - Done")
	else
		TargetActor.Disable()
		StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_DeathTime_" + TempNPCName)
		StorageUtil.UnSetFloatValue(NBFRegForm, "NBF_RegisteredNPC_NPCSpawnTime_" + TempNPCName)
		NBF_Log("FindEmptyAlias - Error")
		return
	endif
	TargetActor.SetFactionRank(CurrentFollowerFaction, -2)
	TargetActor.SetFactionRank(PotentialFollowerFaction, -2)
	TargetActor.SetFactionRank(PotentialMarriageFaction, -2)
	TargetActor.SetFactionRank(Playerfaction, -2)
	if LocationType == 0
		TargetActor.RemoveFromAllFactions()
		TargetActor.SetFactionRank(FactionList[0], 1)
		TargetActor.SetRelationshipRank(PlayerRef, 0)
		TargetActor.SetCrimeFaction(None)
		TargetActor.SetActorValue("Aggression", 1.0)
		TargetActor.SetActorValue("Confidence", 4.0)
		TargetActor.SetActorValue("Morality", 0.0)
		TargetActor.SetActorValue("Assistance", 2.0)
		SetRandomPackage(TargetActor, NPCAlias[Index], TempNPCName)
		(NPCAlias[Index] as _NBF_NPCAlias).TestIntFunction()
	elseif LocationType == 1
		TargetActor.RemoveFromAllFactions()
		TargetActor.SetFactionRank(FactionList[1], 1)
		TargetActor.SetRelationshipRank(PlayerRef, 0)
		TargetActor.SetCrimeFaction(None)
		TargetActor.SetActorValue("Aggression", 1.0)
		TargetActor.SetActorValue("Confidence", 4.0)
		TargetActor.SetActorValue("Morality", 0.0)
		TargetActor.SetActorValue("Assistance", 2.0)
		SetRandomPackage(TargetActor, NPCAlias[Index], TempNPCName)
		(NPCAlias[Index] as _NBF_NPCAlias).TestIntFunction()
	elseif LocationType == 2
		TargetActor.RemoveFromAllFactions()
		TargetActor.SetFactionRank(FactionList[2], 1)
		TargetActor.SetRelationshipRank(PlayerRef, 0)
		TargetActor.SetCrimeFaction(None)
		TargetActor.SetActorValue("Aggression", 1.0)
		TargetActor.SetActorValue("Confidence", 4.0)
		TargetActor.SetActorValue("Morality", 0.0)
		TargetActor.SetActorValue("Assistance", 2.0)
		SetRandomPackage(TargetActor, NPCAlias[Index], TempNPCName)
		(NPCAlias[Index] as _NBF_NPCAlias).TestIntFunction()
	elseif LocationType == 3
		TargetActor.RemoveFromAllFactions()
		TargetActor.SetFactionRank(FactionList[3], 1)
		TargetActor.SetRelationshipRank(PlayerRef, 0)
		TargetActor.SetCrimeFaction(None)
		TargetActor.SetActorValue("Aggression", 1.0)
		TargetActor.SetActorValue("Confidence", 4.0)
		TargetActor.SetActorValue("Morality", 0.0)
		TargetActor.SetActorValue("Assistance", 2.0)
		SetRandomPackage(TargetActor, NPCAlias[Index], TempNPCName)
		(NPCAlias[Index] as _NBF_NPCAlias).TestIntFunction()
	elseif LocationType == 4
		TargetActor.RemoveFromAllFactions()
		TargetActor.SetFactionRank(FactionList[4], 1)
		TargetActor.SetRelationshipRank(PlayerRef, 0)
		TargetActor.SetCrimeFaction(None)
		TargetActor.SetActorValue("Aggression", 1.0)
		TargetActor.SetActorValue("Confidence", 4.0)
		TargetActor.SetActorValue("Morality", 0.0)
		TargetActor.SetActorValue("Assistance", 2.0)
		SetRandomPackage(TargetActor, NPCAlias[Index], TempNPCName)
		(NPCAlias[Index] as _NBF_NPCAlias).TestIntFunction()
	elseif LocationType == 5
		TargetActor.SetFactionRank(FactionList[5], 1)
		TargetActor.SetRelationshipRank(PlayerRef, 0)
	elseif LocationType == 6
		TargetActor.SetFactionRank(FactionList[6], 1)
		TargetActor.SetRelationshipRank(PlayerRef, 0)
	elseif LocationType == 7
		TargetActor.RemoveFromAllFactions()
		TargetActor.SetFactionRank(FactionList[7], 1)
		TargetActor.SetfactionRank(GuardFaction, 1)
		TargetActor.SetfactionRank(GuardDialogueFaction, 1)
		TargetActor.SetFactionRank(CrimeFactionWhiterun, 1)
		TargetActor.SetCrimeFaction(CrimeFactionWhiterun)
		TargetActor.SetActorValue("Aggression", 1.0)
		TargetActor.SetActorValue("Confidence", 3.0)
		TargetActor.SetActorValue("Morality", 0.0)
		TargetActor.SetActorValue("Assistance", 1.0)
		TargetActor.SetRelationshipRank(PlayerRef, 0)
		SetRandomPackage(TargetActor, NPCAlias[Index], TempNPCName)
		(NPCAlias[Index] as _NBF_NPCAlias).TestIntFunction()
	elseif LocationType == 8
		TargetActor.RemoveFromAllFactions()
		TargetActor.SetFactionRank(FactionList[8], 1)
		TargetActor.SetfactionRank(GuardFaction, 1)
		TargetActor.SetfactionRank(GuardDialogueFaction, 1)
		TargetActor.SetRelationshipRank(PlayerRef, 0)
		TargetActor.SetCrimeFaction(CrimeFactionDawnstar)
		TargetActor.SetActorValue("Aggression", 1.0)
		TargetActor.SetActorValue("Confidence", 4.0)
		TargetActor.SetActorValue("Morality", 0.0)
		TargetActor.SetActorValue("Assistance", 1.0)
		SetRandomPackage(TargetActor, NPCAlias[Index], TempNPCName)
		(NPCAlias[Index] as _NBF_NPCAlias).TestIntFunction()
	elseif LocationType == 9
		TargetActor.RemoveFromAllFactions()
		TargetActor.SetFactionRank(FactionList[9], 1)
		TargetActor.SetfactionRank(GuardFaction, 1)
		TargetActor.SetfactionRank(GuardDialogueFaction, 1)
		TargetActor.SetRelationshipRank(PlayerRef, 0)
		TargetActor.SetCrimeFaction(CrimeFactionFalkreath)
		TargetActor.SetActorValue("Aggression", 1.0)
		TargetActor.SetActorValue("Confidence", 3.0)
		TargetActor.SetActorValue("Morality", 0.0)
		TargetActor.SetActorValue("Assistance", 1.0)
		SetRandomPackage(TargetActor, NPCAlias[Index], TempNPCName)
		(NPCAlias[Index] as _NBF_NPCAlias).TestIntFunction()
	elseif LocationType == 10
		TargetActor.RemoveFromAllFactions()
		TargetActor.SetFactionRank(FactionList[10], 1)
		TargetActor.SetfactionRank(GuardFaction, 1)
		TargetActor.SetfactionRank(GuardDialogueFaction, 1)
		TargetActor.SetRelationshipRank(PlayerRef, 0)
		TargetActor.SetCrimeFaction(CrimeFactionMarkarth)
		TargetActor.SetActorValue("Aggression", 1.0)
		TargetActor.SetActorValue("Confidence", 3.0)
		TargetActor.SetActorValue("Morality", 0.0)
		TargetActor.SetActorValue("Assistance", 1.0)
		SetRandomPackage(TargetActor, NPCAlias[Index], TempNPCName)
		(NPCAlias[Index] as _NBF_NPCAlias).TestIntFunction()
	elseif LocationType == 11
		TargetActor.RemoveFromAllFactions()
		TargetActor.SetFactionRank(FactionList[11], 1)
		TargetActor.SetfactionRank(GuardFaction, 1)
		TargetActor.SetfactionRank(GuardDialogueFaction, 1)
		TargetActor.SetRelationshipRank(PlayerRef, 0)
		TargetActor.SetCrimeFaction(CrimeFactionMorthal)
		TargetActor.SetActorValue("Aggression", 1.0)
		TargetActor.SetActorValue("Confidence", 3.0)
		TargetActor.SetActorValue("Morality", 0.0)
		TargetActor.SetActorValue("Assistance", 1.0)
		SetRandomPackage(TargetActor, NPCAlias[Index], TempNPCName)
		(NPCAlias[Index] as _NBF_NPCAlias).TestIntFunction()
	elseif LocationType == 12
		TargetActor.RemoveFromAllFactions()
		TargetActor.SetFactionRank(FactionList[12], 1)
		TargetActor.SetfactionRank(GuardFaction, 1)
		TargetActor.SetfactionRank(GuardDialogueFaction, 1)
		TargetActor.SetRelationshipRank(PlayerRef, 0)
		TargetActor.SetCrimeFaction(CrimeFactionRiften)
		TargetActor.SetActorValue("Aggression", 1.0)
		TargetActor.SetActorValue("Confidence", 3.0)
		TargetActor.SetActorValue("Morality", 0.0)
		TargetActor.SetActorValue("Assistance", 1.0)
		SetRandomPackage(TargetActor, NPCAlias[Index], TempNPCName)
		(NPCAlias[Index] as _NBF_NPCAlias).TestIntFunction()
	elseif LocationType == 13
		TargetActor.RemoveFromAllFactions()
		TargetActor.SetFactionRank(FactionList[13], 1)
		TargetActor.SetfactionRank(GuardFaction, 1)
		TargetActor.SetfactionRank(GuardDialogueFaction, 1)
		TargetActor.SetRelationshipRank(PlayerRef, 0)
		TargetActor.SetCrimeFaction(CrimeFactionSolitude)
		TargetActor.SetActorValue("Aggression", 1.0)
		TargetActor.SetActorValue("Confidence", 3.0)
		TargetActor.SetActorValue("Morality", 0.0)
		TargetActor.SetActorValue("Assistance", 1.0)
		SetRandomPackage(TargetActor, NPCAlias[Index], TempNPCName)
		(NPCAlias[Index] as _NBF_NPCAlias).TestIntFunction()
	elseif LocationType == 14
		TargetActor.RemoveFromAllFactions()
		TargetActor.SetFactionRank(FactionList[14], 1)
		TargetActor.SetfactionRank(GuardFaction, 1)
		TargetActor.SetfactionRank(GuardDialogueFaction, 1)
		TargetActor.SetRelationshipRank(PlayerRef, 0)
		TargetActor.SetCrimeFaction(CrimeFactionWindhelm)
		TargetActor.SetActorValue("Aggression", 1.0)
		TargetActor.SetActorValue("Confidence", 3.0)
		TargetActor.SetActorValue("Morality", 0.0)
		TargetActor.SetActorValue("Assistance", 1.0)
		SetRandomPackage(TargetActor, NPCAlias[Index], TempNPCName)
		(NPCAlias[Index] as _NBF_NPCAlias).TestIntFunction()
	elseif LocationType == 15
		TargetActor.RemoveFromAllFactions()
		TargetActor.SetFactionRank(FactionList[15], 1)
		TargetActor.SetfactionRank(GuardFaction, 1)
		TargetActor.SetfactionRank(GuardDialogueFaction, 1)
		TargetActor.SetRelationshipRank(PlayerRef, 0)
		TargetActor.SetCrimeFaction(CrimeFactionWinterhold)
		TargetActor.SetActorValue("Aggression", 1.0)
		TargetActor.SetActorValue("Confidence", 3.0)
		TargetActor.SetActorValue("Morality", 0.0)
		TargetActor.SetActorValue("Assistance", 1.0)
		SetRandomPackage(TargetActor, NPCAlias[Index], TempNPCName)
		(NPCAlias[Index] as _NBF_NPCAlias).TestIntFunction()
	elseif LocationType == 16
		TargetActor.RemoveFromAllFactions()
		TargetActor.SetFactionRank(FactionList[16], 1)
		TargetActor.SetfactionRank(GuardFaction, 1)
		TargetActor.SetfactionRank(GuardDialogueFaction, 1)
		TargetActor.SetRelationshipRank(PlayerRef, 0)
	endif
	StorageUtil.SetFormValue(NBFRegForm, "NBF_RegisteredNPC_SpawnedNPCbyName_" + TempNPCName, TargetActor)
	StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredNPC_NPCStatus_" + TempNPCName, 1)
	StorageUtil.SetFloatValue(NBFRegForm, "NBF_RegisteredNPC_LastSpawnTime_" + LocationType, Utility.GetCurrentGameTime())
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredNPC_SpawnedActorBaseList", TargetActor.GetActorBase())
EndFunction

int Function FindEmptyAlias(Actor TargetActor, bool Fill)
	Int ArrayLength = NPCAlias.Length
	Int Index = 0
	NBF_Log("FindEmptyAlias - ArrayLength " + ArrayLength)
	While Index < ArrayLength
		if Fill
			if NPCAlias[Index].GetActorReference() == None
				NBF_Log("FindEmptyAlias - Found Empty " + Index)
				NPCAlias[Index].ForceRefTo(TargetActor)
				(NPCAlias[Index] as _NBF_NPCAlias).TestInt = 100
				(NPCAlias[Index] as _NBF_NPCAlias).TestIntFunction()
				(NPCAlias[Index] as _NBF_NPCAlias).Init()
				return Index
			endif
		else
			if NPCAlias[Index].GetActorReference() == TargetActor
				(NPCAlias[Index] as _NBF_NPCAlias).Behavior = ""
				(NPCAlias[Index] as _NBF_NPCAlias).SubPackageName = ""
				(NPCAlias[Index] as _NBF_NPCAlias).SubPackageIndex = -1		
				NPCAlias[Index].Clear()
				return Index
			endif
		endif
		Index +=1
	endwhile
	return -1
EndFunction

Function AliasMaintenance()
	Int ArrayLength = NPCAlias.Length
	Int Index = 0
	While Index < ArrayLength
		Actor TempActor = NPCAlias[Index].GetActorReference()
		if TempActor
			if TempActor.IsDisabled() || TempActor.IsDead()
				NBF_Log("AliasMaintenance - Clearing Empty " + Index)
				NPCAlias[Index].Clear()
			endif
		endif
		Index +=1
	endwhile
EndFunction

Function SetRandomPackage(Actor TargetActor, ReferenceAlias TargetAlias, String NPCName)
	String TempBehavior = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_Behavior_ByNPCName" + NPCName)
	String TempPackageSubSetName = StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + NPCName)
	Package[] TempPackageSet = GetSubPackageSetByName(TempBehavior, StorageUtil.GetStringValue(NBFRegForm, "NBF_RegisteredNPC_BehaviorPackage_ByNPCName" + NPCName))
	NBF_Log("SetRandomPackage - TempBehavior: " + TempBehavior + " TempPackageSubSetName: " + TempPackageSubSetName)
	Int ArrayLength = NPCAlias.Length
	While ArrayLength > 0
		ArrayLength -= 1
		if NPCAlias[ArrayLength].GetActorReference()
			if (NPCAlias[ArrayLength] as _NBF_NPCAlias).Behavior == TempBehavior
				if (NPCAlias[ArrayLength] as _NBF_NPCAlias).SubPackageIndex >= 0
					StorageUtil.IntListAdd(NBFRegForm, "NBF_SetRandomPackage_TempData2", (NPCAlias[ArrayLength] as _NBF_NPCAlias).SubPackageIndex, true)
					NBF_Log("SetRandomPackage - NBF_SetRandomPackage_TempData2 - ArrayLength: " + ArrayLength + " SubPackageIndex: " + (NPCAlias[ArrayLength] as _NBF_NPCAlias).SubPackageIndex)
				endif
			endif
		endif
	endwhile
	ArrayLength = -1
	ArrayLength = TempPackageSet.Length
	Int TotalWeight = 0
	
	StorageUtil.IntListResize(NBFRegForm, "NBF_SetRandomPackage_TempData", ArrayLength)
	While ArrayLength > 0
		ArrayLength -= 1
		Int IndexWeight = ((1000 / TempPackageSet.Length) / ( 1 + (StorageUtil.IntListCountValue(NBFRegForm, "NBF_SetRandomPackage_TempData2", ArrayLength) * 3))) as int
		TotalWeight += IndexWeight
		NBF_Log("SetRandomPackage - NBF_SetRandomPackage_TempData - ArrayLength: " + ArrayLength + " IndexWeight: " + IndexWeight + " TotalWeight: " + TotalWeight)
		StorageUtil.IntListSet(NBFRegForm, "NBF_SetRandomPackage_TempData", ArrayLength, IndexWeight)
	endwhile
	
	Int RandomWeight = Utility.RandomInt(0, TotalWeight)
	Int SavedIndex = -1
	ArrayLength = TempPackageSet.Length
	While ArrayLength > 0 && SavedIndex == -1
		ArrayLength -= 1
		NBF_Log("SetRandomPackage - Picking - ArrayLength: " + ArrayLength + " RandomWeight: " + RandomWeight + " IndexWeight: " + StorageUtil.IntListGet(NBFRegForm, "NBF_SetRandomPackage_TempData", ArrayLength))
		if RandomWeight <= StorageUtil.IntListGet(NBFRegForm, "NBF_SetRandomPackage_TempData", ArrayLength)
			SavedIndex = ArrayLength
			NBF_Log("SetRandomPackage - Picking - SavedIndex: " + SavedIndex)
		else
			RandomWeight -= StorageUtil.IntListGet(NBFRegForm, "NBF_SetRandomPackage_TempData", ArrayLength)
			NBF_Log("SetRandomPackage - Picking - RandomWeight: " + RandomWeight)
		endif
	endwhile
	if SavedIndex == -1
		SavedIndex == TempPackageSet.Length - 1
	endif
	
	StorageUtil.IntListClear(NBFRegForm, "NBF_SetRandomPackage_TempData")
	StorageUtil.IntListClear(NBFRegForm, "NBF_SetRandomPackage_TempData2")
	
	NBF_Log("SetRandomPackage - Complete - SavedIndex: " + SavedIndex)
	
	Package TempPackage = TempPackageSet[SavedIndex]
	ActorUtil.AddPackageOverride(TargetActor, TempPackage, 100)
	(TargetAlias as _NBF_NPCAlias).Behavior = TempBehavior
	(TargetAlias as _NBF_NPCAlias).SubPackageName = TempPackageSubSetName
	(TargetAlias as _NBF_NPCAlias).SubPackageIndex = SavedIndex
	NBF_Log("SetRandomPackage - SavedIndex: " + SavedIndex)
	TargetActor.EvaluatePackage()
	
	
;	Int Index = Utility.RandomInt(0, ArrayLength - 1)
;	Package TempPackage = TempPackageSet[Index]
;	ActorUtil.AddPackageOverride(TargetActor, TempPackage, 100)
;	(TargetAlias as _NBF_NPCAlias).Behavior = TempBehavior
;	(TargetAlias as _NBF_NPCAlias).SubPackageName = TempPackageSubSetName
;	(TargetAlias as _NBF_NPCAlias).SubPackageIndex = Index
;	NBF_Log("SetRandomPackage - Index: " + Index)
;	TargetActor.EvaluatePackage()
EndFunction

Function SetPackage(Actor TargetActor, Package[] PackageSet, Int Index)
	Package TempPackage = PackageSet[Index]
	ActorUtil.AddPackageOverride(TargetActor, TempPackage, 100)
	TargetActor.EvaluatePackage()
EndFunction

Function RemovePackageSet(Actor TargetActor, Package[] PackageSet)
	Int ArrayLength = PackageSet.Length
	Int Index = 0
	While ArrayLength > Index
		Package TempPackage = PackageSet[Index]
		ActorUtil.RemovePackageOverride(TargetActor, TempPackage)
		Index += 1
	endwhile
	TargetActor.EvaluatePackage()
EndFunction

Function RegisterPatrolMarkers()
	ObjectReference TempPatrolMarker
	String SubPackage
	
	;_NBF_Whiterun_Patrol_A
	SubPackage = PackageStorage.GuardWhiterun_SetName[0]
	NBF_Log("RegisterPatrolMarkers: " + SubPackage)
	StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_SubPackageCount", 3)
	TempPatrolMarker = Game.GetFormFromFile(0x4767C, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x4767D, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x4767E, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x4767F, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x47680, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x47681, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x47682, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x47683, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x47684, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x4C787, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x4C788, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x4C789, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	NBF_Log("RegisterPatrolMarkers: " + StorageUtil.FormListCount(NBFRegForm, "NBF_RegisteredMarkers_GuardWhiterunSubPackageA"))
	
	;_NBF_Whiterun_Patrol_B
	TempPatrolMarker = Game.GetFormFromFile(0x5188D, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x5188E, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x5188F, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x51890, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x51891, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x51892, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x51893, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x51894, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x51895, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x51896, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	
	;_NBF_Whiterun_Patrol_C
	TempPatrolMarker = Game.GetFormFromFile(0x51897, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x51898, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x51899, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x5189A, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x5189B, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x5189C, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x5189D, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x5189E, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	
	;_NBF_Whiterun_Patrol_D
	SubPackage = PackageStorage.GuardWhiterun_SetName[1]
	StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_SubPackageCount", 4)
	TempPatrolMarker = Game.GetFormFromFile(0x7A0B2, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7A0B3, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7A0B4, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7A0B5, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7A0B6, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7A0B7, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7A0B8, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7A0B9, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7A0BA, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7A0BB, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7A0BC, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	
	;_NBF_Whiterun_Patrol_E
	TempPatrolMarker = Game.GetFormFromFile(0x7F1BE, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1BF, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1C0, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1C2, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1C3, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1C4, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1C5, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1C6, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1C7, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1C8, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1C9, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1CA, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	
	;_NBF_Whiterun_Patrol_F
	TempPatrolMarker = Game.GetFormFromFile(0x7F1CB, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1CC, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1CD, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1CE, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1CF, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1D0, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1D1, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1D2, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1D3, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	
	;_NBF_Riverwood_Patrol_A
	TempPatrolMarker = Game.GetFormFromFile(0x7F1D4, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1D5, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x7F1D6, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[7] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	
	SubPackage = PackageStorage.GuardDawnstar_SetName[0]
	StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_SubPackageCount", 2)
	
	;_NBF_Dawnstar_Patrol_A
	
	TempPatrolMarker = Game.GetFormFromFile(0x893DD, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893DE, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893DF, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893E0, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893E1, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893E2, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893E3, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893E4, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893E5, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893E6, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	
	;_NBF_Dawnstar_Patrol_B
	
	TempPatrolMarker = Game.GetFormFromFile(0x893E7, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893E8, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893E9, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893EA, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893EB, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893EC, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893ED, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893EE, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893EF, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893F0, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893F1, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893F2, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	
	SubPackage = PackageStorage.GuardFalkreath_SetName[0]
	StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_SubPackageCount", 4)
	
	;_NBF_Falkreath_Patrol_A
	
	TempPatrolMarker = Game.GetFormFromFile(0x893F3, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893F4, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893F5, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893F6, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	
	;_NBF_Falkreath_Patrol_B
	
	TempPatrolMarker = Game.GetFormFromFile(0x893F7, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893F8, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893F9, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893FA, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893FB, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893FC, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893FD, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	
	;_NBF_Falkreath_Patrol_C
	
	TempPatrolMarker = Game.GetFormFromFile(0x893FE, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x893FF, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89400, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89401, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89402, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89403, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89404, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89405, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89406, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89407, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	
	;_NBF_Falkreath_Patrol_D
	
	TempPatrolMarker = Game.GetFormFromFile(0x89408, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89409, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8940A, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8940B, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8940C, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8940D, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8940E, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[9] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	
	SubPackage = PackageStorage.GuardMarkarth_SetName[0]
	StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_SubPackageCount", 4)
	
	;_NBF_Markarth_Patrol_A
	
	TempPatrolMarker = Game.GetFormFromFile(0x89411, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89412, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89413, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89414, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89415, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89416, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89417, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89418, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89419, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8941A, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8941B, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8941C, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8941D, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8941E, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8941F, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	
	;_NBF_Markarth_Patrol_B
	
	TempPatrolMarker = Game.GetFormFromFile(0x89420, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89422, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89423, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89424, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89425, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89426, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89427, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89428, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89429, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8942A, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8942B, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8942C, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8942D, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8942E, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8942F, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89430, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	
	;_NBF_Markarth_Patrol_C
	
	TempPatrolMarker = Game.GetFormFromFile(0x89421, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89431, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89432, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89433, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89434, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89435, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89436, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89437, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89438, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x89439, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8943A, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8943B, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x8943C, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	
	;_NBF_Markarth_Patrol_D
	
	TempPatrolMarker = Game.GetFormFromFile(0x93644, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x93645, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x93646, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x93647, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x93648, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x93649, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9364A, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9364B, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9364C, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9364D, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	
	SubPackage = PackageStorage.GuardMarkarth_SetName[1]
	StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_SubPackageCount", 2)
	
	;_NBF_Markarth_Patrol_E
	
	TempPatrolMarker = Game.GetFormFromFile(0x93652, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x93654, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x93655, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x93656, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x93657, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x93658, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x93659, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	
	;_NBF_Markarth_Patrol_F
	
	TempPatrolMarker = Game.GetFormFromFile(0x9365A, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9365B, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9365C, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9365D, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[10] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	
	SubPackage = PackageStorage.GuardRiften_SetName[0]
	StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_SubPackageCount", 3)
	
	;_NBF_Riften_Patrol_A
	
	TempPatrolMarker = Game.GetFormFromFile(0x9366A, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9366B, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9366C, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9366D, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9366E, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9366F, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x93670, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x93671, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x93672, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	
	;_NBF_Riften_Patrol_B
	
	TempPatrolMarker = Game.GetFormFromFile(0x9877D, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9877E, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9877F, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98780, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98781, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98782, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98783, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98784, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98785, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98786, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	
	;_NBF_Riften_Patrol_C
	
	TempPatrolMarker = Game.GetFormFromFile(0x98787, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98790, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98791, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98792, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98793, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98794, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98795, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98796, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98797, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98798, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98799, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9879A, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9879B, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9879C, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9879D, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	
	SubPackage = PackageStorage.GuardRiften_SetName[1]
	StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_SubPackageCount", 4)
	
	;_NBF_Riften_Patrol_D
	
	TempPatrolMarker = Game.GetFormFromFile(0x9879E, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9879F, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987A0, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987A1, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987A2, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987A3, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987A4, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987A5, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987A6, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987A7, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987A8, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987A9, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	
	;_NBF_Riften_Patrol_E
	
	TempPatrolMarker = Game.GetFormFromFile(0x987AA, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987AB, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987AC, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987AD, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987AE, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987AF, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987B0, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987B1, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987B2, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987B3, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987B4, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987B5, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	
;	_NBF_Riften_Patrol_F
	
	TempPatrolMarker = Game.GetFormFromFile(0x987B6, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987B7, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987B8, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987B9, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987BA, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987BB, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987BC, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987BD, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987BE, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987BF, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	
;	_NBF_Riften_Patrol_G
	
	TempPatrolMarker = Game.GetFormFromFile(0x987C0, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987C1, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987C2, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987C3, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987C4, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987C5, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987C6, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987C7, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987C8, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987C9, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[12] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	
	SubPackage = PackageStorage.GuardSolitude_SetName[0]
	StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_SubPackageCount", 4)
	
;	_NBF_Solitude_Patrol_A

	TempPatrolMarker = Game.GetFormFromFile(0x987CA, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987D1, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987D2, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987D3, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987D4, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987D5, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987D6, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987D7, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987D8, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987D9, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987DA, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987DB, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987DC, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987DD, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987DE, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_1", TempPatrolMarker, false)

;	_NBF_Solitude_Patrol_B

	TempPatrolMarker = Game.GetFormFromFile(0x987DF, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987F2, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987F3, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987F4, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987F5, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987F6, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987F7, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987F8, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987F9, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987FA, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987FB, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987FC, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987FD, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987FE, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x987FF, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98800, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98801, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98802, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98803, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)

;	_NBF_Solitude_Patrol_C

	TempPatrolMarker = Game.GetFormFromFile(0x98804, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98805, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98806, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98807, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98808, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98809, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9880A, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9880B, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9880C, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9880D, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9880E, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9880F, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98810, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98811, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98812, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98813, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)

;	_NBF_Solitude_Patrol_D

	TempPatrolMarker = Game.GetFormFromFile(0x98814, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98815, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98816, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98817, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98818, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x98819, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9881A, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9881B, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9881C, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9881D, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_4", TempPatrolMarker, false)
	
	SubPackage = PackageStorage.GuardSolitude_SetName[1]
	StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_SubPackageCount", 3)
	
;	_NBF_Solitude_Patrol_E
	
	TempPatrolMarker = Game.GetFormFromFile(0x9D921, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D922, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D923, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D924, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	
;	_NBF_Solitude_Patrol_F
	
	TempPatrolMarker = Game.GetFormFromFile(0x9D925, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D926, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D927, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D928, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D929, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D92A, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D92B, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D92C, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D92D, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	
;	_NBF_Solitude_Patrol_G
	
	TempPatrolMarker = Game.GetFormFromFile(0x9D92E, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D92F, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D930, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D931, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D932, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D933, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D934, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D935, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D936, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D937, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[13] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	
	SubPackage = PackageStorage.GuardWindhelm_SetName[0]
	StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_SubPackageCount", 3)
	
;	_NBF_Windhelm_Patrol_A

	TempPatrolMarker = Game.GetFormFromFile(0x9D940, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D941, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D942, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D943, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D944, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D945, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D946, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D947, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D948, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D949, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D94A, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_1", TempPatrolMarker, false)

;	_NBF_Windhelm_Patrol_B

	TempPatrolMarker = Game.GetFormFromFile(0x9D94C, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D94E, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D94F, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D950, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D951, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D952, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D953, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D954, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_2", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D955, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_2", TempPatrolMarker, false)

;	_NBF_Windhelm_Patrol_C

	TempPatrolMarker = Game.GetFormFromFile(0x9D956, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D957, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D958, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D959, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D95A, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D95B, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D95C, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_3", TempPatrolMarker, false)
	
	SubPackage = PackageStorage.GuardWindhelm_SetName[1]
	StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_SubPackageCount", 1)
	
;	_NBF_Windhelm_Patrol_D
	
	TempPatrolMarker = Game.GetFormFromFile(0x9D95D, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D95E, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D95F, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D960, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D961, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0x9D962, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[14] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	
	SubPackage = PackageStorage.GuardMorthal_SetName[0]
	StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[11] + "_" + SubPackage + "_SubPackageCount", 1)
	
;	_NBF_Morthal_Patrol_A

	TempPatrolMarker = Game.GetFormFromFile(0xA2A5D, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[11] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0xA2A5E, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[11] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0xA2A5F, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[11] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0xA2A60, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[11] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0xA2A61, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[11] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0xA2A62, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[11] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0xA2A63, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[11] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0xA2A64, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[11] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0xA2A65, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[11] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0xA2A66, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[11] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0xA2A67, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[11] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	
	SubPackage = PackageStorage.GuardWinterhold_SetName[0]
	StorageUtil.SetIntValue(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[15] + "_" + SubPackage + "_SubPackageCount", 1)
	
;	_NBF_Winterhold_Patrol_A
	
	TempPatrolMarker = Game.GetFormFromFile(0xA2A68, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[15] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	TempPatrolMarker = Game.GetFormFromFile(0xA2A69, "LRG NPC behaviour Framework.esp") as ObjectReference
	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[15] + "_" + SubPackage + "_1", TempPatrolMarker, false)
	
;	TempPatrolMarker = Game.GetFormFromFile(0x0, "LRG NPC behaviour Framework.esp") as ObjectReference
;	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_GuardWhiterunSubPackageA", TempPatrolMarker, false)
;	TempPatrolMarker = Game.GetFormFromFile(0x0, "LRG NPC behaviour Framework.esp") as ObjectReference
;	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_GuardWhiterunSubPackageA", TempPatrolMarker, false)
	
;	TempPatrolMarker = Game.GetFormFromFile(0x, "LRG NPC behaviour Framework.esp") as ObjectReference
;	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_GuardWhiterunSubPackageB", TempPatrolMarker, false)


;	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_GuardWhiterunSubPackageB", TempPatrolMarker, false)

;	TempPatrolMarker = Game.GetFormFromFile(0x, "LRG NPC behaviour Framework.esp") as ObjectReference
;	StorageUtil.FormListAdd(NBFRegForm, "NBF_RegisteredMarkers_" + BehaviourList[8] + "_" + SubPackage + "_1", TempPatrolMarker, false)
EndFunction

Package[] Function GetSubPackageSetByName(String Behavior, String SetName)
	NBF_Log("GetSubPackageSetByName")
	if Behavior == "Bandit"
		if SetName == PackageStorage.Sandbox_SetName[0]
			NBF_Log(SetName)
			return PackageStorage.Sandbox_PackageSetSubA
		endif
	elseif Behavior == "Forsworn"
		if SetName == PackageStorage.Sandbox_SetName[0]
			NBF_Log(SetName)
			return PackageStorage.Sandbox_PackageSetSubA
		endif
	elseif Behavior == "Vampire"
		if SetName == PackageStorage.Sandbox_SetName[0]
			NBF_Log(SetName)
			return PackageStorage.Sandbox_PackageSetSubA
		endif
	elseif Behavior == "Necromancer"
		if SetName == PackageStorage.Sandbox_SetName[0]
			NBF_Log(SetName)
			return PackageStorage.Sandbox_PackageSetSubA
		endif
	elseif Behavior == "Warlock"
		if SetName == PackageStorage.Sandbox_SetName[0]
			NBF_Log(SetName)
			return PackageStorage.Sandbox_PackageSetSubA
		endif
	elseif Behavior == "Imperial Solder"
		if SetName == PackageStorage.Sandbox_SetName[0]
			NBF_Log(SetName)
			return PackageStorage.Sandbox_PackageSetSubA
		endif
	elseif Behavior == "Stormcloack Solder"
		if SetName == PackageStorage.Sandbox_SetName[0]
			NBF_Log(SetName)
			return PackageStorage.Sandbox_PackageSetSubA
		endif
	elseif Behavior == "Guard(Whiterun)"
		if SetName == PackageStorage.GuardWhiterun_SetName[0]
			NBF_Log(SetName)
			return PackageStorage.GuardWhiterun_PackageSetSubA
		elseif SetName == PackageStorage.GuardWhiterun_SetName[1]
			NBF_Log(SetName)
			return PackageStorage.GuardWhiterun_PackageSetSubB
		endif
	elseif Behavior == "Guard(Dawnstar)"
		if SetName == PackageStorage.GuardDawnstar_SetName[0]
			NBF_Log(SetName)
			return PackageStorage.GuardDawnstar_PackageSetSubA
		endif
	elseif Behavior == "Guard(Falkreath)"
		if SetName == PackageStorage.GuardFalkreath_SetName[0]
			NBF_Log(SetName)
			return PackageStorage.GuardFalkreath_PackageSetSubA
		endif
	elseif Behavior == "Guard(Markarth)"
		if SetName == PackageStorage.GuardMarkarth_SetName[0]
			NBF_Log(SetName)
			return PackageStorage.GuardMarkarth_PackageSetSubA
		elseif SetName == PackageStorage.GuardMarkarth_SetName[1]
			NBF_Log(SetName)
			return PackageStorage.GuardMarkarth_PackageSetSubB
		endif
	elseif Behavior == "Guard(Morthal)"
		if SetName == PackageStorage.GuardMorthal_SetName[0]
			NBF_Log(SetName)
			return PackageStorage.GuardMorthal_PackageSetSubA
		endif
	elseif Behavior == "Guard(Riften)"
		if SetName == PackageStorage.GuardRiften_SetName[0]
			NBF_Log(SetName)
			return PackageStorage.GuardRiften_PackageSetSubA
		elseif SetName == PackageStorage.GuardRiften_SetName[1]
			NBF_Log(SetName)
			return PackageStorage.GuardRiften_PackageSetSubB
		endif
	elseif Behavior == "Guard(Solitude)"
		if SetName == PackageStorage.GuardSolitude_SetName[0]
			NBF_Log(SetName)
			return PackageStorage.GuardSolitude_PackageSetSubA
		elseif SetName == PackageStorage.GuardSolitude_SetName[1]
			NBF_Log(SetName)
			return PackageStorage.GuardSolitude_PackageSetSubB
		endif
	elseif Behavior == "Guard(Windhelm)"
		if SetName == PackageStorage.GuardWindhelm_SetName[0]
			NBF_Log(SetName)
			return PackageStorage.GuardWindhelm_PackageSetSubA
		elseif SetName == PackageStorage.GuardWindhelm_SetName[1]
			NBF_Log(SetName)
			return PackageStorage.GuardWindhelm_PackageSetSubB
		endif
	elseif Behavior == "Guard(Winterhold)"
		if SetName == PackageStorage.GuardWinterhold_SetName[0]
			NBF_Log(SetName)
			return PackageStorage.GuardWinterhold_PackageSetSubA
		endif
	elseif Behavior == "Guard(CidhnaMine)"
		if SetName == PackageStorage.GuardCidhnaMine_SetName[0]
			NBF_Log(SetName)
			return PackageStorage.GuardCidhnaMine_PackageSetSubA
		endif
	endif
EndFunction


String[] Function GetSetNameByBehavior(String Behavior)
	NBF_Log("GetSetNameByBehavior")
	if Behavior == "Bandit"
		NBF_Log("GetSetNameByBehavior - Bandit")
		return PackageStorage.Sandbox_SetName
	elseif Behavior == "Forsworn"
		NBF_Log("GetSetNameByBehavior - Forsworn")
		return PackageStorage.Sandbox_SetName
	elseif Behavior == "Vampire"
		NBF_Log("GetSetNameByBehavior - Vampire")
		return PackageStorage.Sandbox_SetName
	elseif Behavior == "Necromancer"
		NBF_Log("GetSetNameByBehavior - Necromancer")
		return PackageStorage.Sandbox_SetName
	elseif Behavior == "Warlock"
		NBF_Log("GetSetNameByBehavior - Warlock")
		return PackageStorage.Sandbox_SetName
	elseif Behavior == "Imperial Solder"
		NBF_Log("GetSetNameByBehavior - Imperial Solder")
		return PackageStorage.Sandbox_SetName
	elseif Behavior == "Stormcloack Solder"
		NBF_Log("GetSetNameByBehavior - Stormcloack Solder")
		return PackageStorage.Sandbox_SetName
	elseif Behavior == "Guard(Whiterun)"
		NBF_Log("GetSetNameByBehavior - Guard(Whiterun)")
		return PackageStorage.GuardWhiterun_SetName
	elseif Behavior == "Guard(Dawnstar)"
		NBF_Log("GetSetNameByBehavior - Guard(Dawnstar)")
		return PackageStorage.GuardDawnstar_SetName
	elseif Behavior == "Guard(Falkreath)"
		NBF_Log("GetSetNameByBehavior - Guard(Falkreath)")
		return PackageStorage.GuardFalkreath_SetName
	elseif Behavior == "Guard(Markarth)"
		NBF_Log("GetSetNameByBehavior - Guard(Markarth)")
		return PackageStorage.GuardMarkarth_SetName
	elseif Behavior == "Guard(Morthal)"
		NBF_Log("GetSetNameByBehavior - Guard(Morthal)")
		return PackageStorage.GuardMorthal_SetName
	elseif Behavior == "Guard(Riften)"
		NBF_Log("GetSetNameByBehavior - Guard(Riften)")
		return PackageStorage.GuardRiften_SetName
	elseif Behavior == "Guard(Solitude)"
		NBF_Log("GetSetNameByBehavior - Guard(Solitude)")
		return PackageStorage.GuardSolitude_SetName
	elseif Behavior == "Guard(Windhelm)"
		NBF_Log("GetSetNameByBehavior - Guard(Windhelm)")
		return PackageStorage.GuardWindhelm_SetName
	elseif Behavior == "Guard(Winterhold)"
		NBF_Log("GetSetNameByBehavior - Guard(Winterhold)")
		return PackageStorage.GuardWinterhold_SetName
	elseif Behavior == "Guard(Windhelm)"
		NBF_Log("GetSetNameByBehavior - Guard(CidhnaMine)")
		return PackageStorage.GuardCidhnaMine_SetName
	endif
EndFunction

Function NBF_Log(String TargetString)
	if MCM.EnableDebugLogging
		Debug.trace("[NBF] - " + TargetString)
	endif
EndFunction